/**
 * Title:        Checklist
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      University Bayreuth
 * @author Dieter Neubacher
 * @version 1.0
 */
package net.metadiversity.diversity.navigator.checklists;

//import java.awt.event.ActionEvent;
import javax.swing.*;

import net.metadiversity.diversity.navigator.checklists.database.DBChecklist;
import net.metadiversity.diversity.navigator.checklists.dataimport.*;
//import net.metadiversity.diversity.navigator.checklists.taxon.*;
//import net.metadiversity.diversity.navigator.checklists.*;

import net.metadiversity.diversity.navigator.gui.DnOptionPane;

// LOGGINGen
import org.apache.log4j.Logger;


public class ChecklistsMainFrame extends javax.swing.JInternalFrame
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3977867280102993970L;

    static Logger logger = Logger.getLogger( ChecklistsMainFrame.class.getName() ); 
    
    private boolean debugFlag = false;
    // Checklists database connection Data
    private DBChecklist db;     // checklists database
    
    // Variables declaration
    
    private static ChecklistsMainFrame mainFrame;

    private static int frameXpos = 200;
    private static int frameYpos = 150;

    private javax.swing.JMenuBar    jMenuBar;
    private javax.swing.JMenu       jMenuFile;
    private javax.swing.JPanel      jMainPanel;
    //-----------------------------------------------------------
    // file menu
    //-----------------------------------------------------------
    // ??? private javax.swing.JMenuItem   jMenuItem;
    private javax.swing.JMenuItem   jMenuItemConvertToXml;
    private javax.swing.JMenuItem   jMenuItemImport;
    private javax.swing.JMenuItem   jMenuItemImportList;
    private javax.swing.JMenuItem   jMenuItemExport;
    private javax.swing.JSeparator  jSeparator1;
    private javax.swing.JMenuItem   jMenuItemGisData;
    private javax.swing.JMenuItem   jMenuItemGisCrossData;
    private javax.swing.JSeparator  jSeparator2;
    private javax.swing.JMenuItem   jMenuItemExit;
    //
    private javax.swing.JMenu       jMenuEdit;
    //-----------------------------------------------------------
    // Tabbed Panel
    //-----------------------------------------------------------
    private javax.swing.JTabbedPane jTabbedPane;
    private javax.swing.JPanel      jPanelTabGenus;
    private javax.swing.JPanel      jPanelTabTaxon;

    private javax.swing.JPanel      jPanelTabSynonym;
    private javax.swing.JPanel      jPanelTabGrassGis;

    //-----------------------------------------------------------
    // Insert menu
    //-----------------------------------------------------------
    /*
    private javax.swing.JMenu       jMenuInsert;
    private javax.swing.JMenuItem   jMenuItemInsertName;
    private javax.swing.JMenuItem   jMenuItemInsertNameGroup;
    private javax.swing.JMenuItem   jMenuItemInsertLocation;
    */
    //-----------------------------------------------------------
    // Genus Tab View
    //-----------------------------------------------------------
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea   jTextArea1;
    /** Creates new form MainFrame */
    public ChecklistsMainFrame()
    {
        super( "Checklists", true, true, true, true );
      	db = new DBChecklist();
        initComponents();
        pack();
    }
    private void initComponents ()
    {
        jMenuBar         = new javax.swing.JMenuBar();
        jMenuFile        = new javax.swing.JMenu();
        jMenuItemConvertToXml  = new javax.swing.JMenuItem();
        jMenuItemImport  = new javax.swing.JMenuItem();
        jMenuItemImportList  = new javax.swing.JMenuItem();
        jMenuItemExport  = new javax.swing.JMenuItem();
        jSeparator1      = new javax.swing.JSeparator();
        jMenuItemGisData = new javax.swing.JMenuItem();
        jMenuItemGisCrossData = new javax.swing.JMenuItem();
        jSeparator2      = new javax.swing.JSeparator();
        jMenuItemExit    = new javax.swing.JMenuItem();
        jMenuEdit        = new javax.swing.JMenu();

	//
	// TabbedPanel
	//
        jMainPanel       = new javax.swing.JPanel();
        jTabbedPane      = new javax.swing.JTabbedPane();
        jPanelTabGenus   = new javax.swing.JPanel();
        jPanelTabTaxon   = new javax.swing.JPanel();
        jPanelTabSynonym = new javax.swing.JPanel();
        jPanelTabGrassGis= new javax.swing.JPanel();

                
        jMainPanel.addComponentListener(new java.awt.event.ComponentAdapter()
        {
            public void componentResized(java.awt.event.ComponentEvent evt)
            {
                logger.debug( "MainPanel: " + evt );
                java.awt.Dimension d = evt.getComponent().getSize();
                // jTabbedPane.setSize( (int) d.getWidth() - 50, (int) d.getHeight() -50  ); 
                jPanelTabGrassGis.setSize( (int) d.getWidth() - 50, (int) d.getHeight() -50  ); 
                pack();
            }
        });
        
        jMenuBar.setMinimumSize( new java.awt.Dimension(400, 19) );
	jMenuFile.setText( "File" );
	//----------------------------
	// File Menu:   Convert to xml
        //----------------------------
	jMenuItemConvertToXml.setText( "ConvertToXml" );
	jMenuItemConvertToXml.addActionListener( new java.awt.event.ActionListener ()
	    {
                public void actionPerformed( java.awt.event.ActionEvent evt )
                {
                    jMenuItemConvertToXmlActionPerformed( evt );
                }
	    }	);
    	jMenuFile.add( jMenuItemConvertToXml );
	//---------------------
	// File Menu:   Import
        //---------------------
	jMenuItemImport.setText( "Import XML" );
	jMenuItemImport.addActionListener( new java.awt.event.ActionListener ()
	    {
                public void actionPerformed( java.awt.event.ActionEvent evt )
                {
                    jMenuItemImportActionPerformed( evt );
                }
	    }	);
    	jMenuFile.add( jMenuItemImport );
	//----------------------------------------------------------------------
	// File Menu:   Import a list of xml files
        //----------------------------------------------------------------------
	jMenuItemImportList.setText( "Import from filelist" );
	jMenuItemImportList.addActionListener( new java.awt.event.ActionListener ()
	    {
                public void actionPerformed( java.awt.event.ActionEvent evt )
                {
                    jMenuItemImportListActionPerformed( evt );
                }
	    }	);
    	jMenuFile.add( jMenuItemImportList );
	//---------------------
	// File Menu:   Export
        //---------------------
	jMenuItemExport.setText( "Export XML" );
	jMenuItemExport.addActionListener( new java.awt.event.ActionListener ()
	    {
                public void actionPerformed( java.awt.event.ActionEvent evt )
                {
                    jMenuItemExportActionPerformed( evt );
                }
	    }   );
    	jMenuFile.add( jMenuItemExport );
	//---------------------
	// File Menu:   GIS Data
        //---------------------
	jMenuFile.add (jSeparator2 );
	jMenuItemGisData.setText( "Gis Data" );
	jMenuItemGisData.addActionListener( new java.awt.event.ActionListener ()
	    {
                public void actionPerformed( java.awt.event.ActionEvent evt )
                {
                    jMenuItemGisDataActionPerformed( evt );
                }
	    }   );
    	jMenuFile.add( jMenuItemGisData );
	//---------------------
	// File Menu:   GIS Cross Data
        //---------------------
	
	jMenuItemGisCrossData.setText( "Gis Cross Data" );
	jMenuItemGisCrossData.addActionListener( new java.awt.event.ActionListener ()
	    {
                public void actionPerformed( java.awt.event.ActionEvent evt )
                {
                    jMenuItemGisCrossDataActionPerformed( evt );
                }
	    }   );
    	jMenuFile.add( jMenuItemGisCrossData );
	//----------------------
	// File Menu:    Exit
	//----------------------
	jMenuFile.add (jSeparator1);
	jMenuItemExit.setText( "Exit" );
	jMenuItemExit.addActionListener( new java.awt.event.ActionListener ()
            {
                public void actionPerformed (java.awt.event.ActionEvent evt)
                {
                    jMenuItemExitActionPerformed( evt );
                }
            }   );
	jMenuFile.add( jMenuItemExit );
	jPanelTabTaxon.setLayout( new java.awt.BorderLayout ());
        
/*
	jPanelTabTaxon.setPreferredSize( new java.awt.Dimension( 800, 400));

        jMainPanel.setPreferredSize(        new java.awt.Dimension( 780, 500 ) );
	jTabbedPane.setPreferredSize(   new java.awt.Dimension( 780, 500 ) );
	jTabbedPane.setMinimumSize(     new java.awt.Dimension( 200, 600 ) );
	jPanelTabGenus.setLayout(        new java.awt.BorderLayout ());
	jPanelTabGenus.setPreferredSize( new java.awt.Dimension( 780, 400 ));
	jPanelTabSynonym.setLayout(        new java.awt.BorderLayout ());
	jPanelTabSynonym.setPreferredSize( new java.awt.Dimension( 780, 400 ));
*/
        jPanelTabGrassGis.add( new net.metadiversity.diversity.navigator.gui.ChecklistsGisVisualisation( db.connect() ) );
        jTabbedPane.addTab( "Grass-Gis", jPanelTabGrassGis );
	jTabbedPane.addTab( "Taxon", jPanelTabTaxon );
	jTabbedPane.addTab( "Synonym", jPanelTabSynonym );
	jTabbedPane.addTab( "Genus", jPanelTabGenus );

        jTabbedPane.setSelectedIndex( 0 );
	//--------------------------------------------------------------
	// init Genus Tab View
	//--------------------------------------------------------------
        jScrollPane1 = new javax.swing.JScrollPane ();
        jTextArea1 = new javax.swing.JTextArea ();
        jScrollPane1.setPreferredSize (new java.awt.Dimension( 700, 400));
	jScrollPane1.setViewportView (jTextArea1);
	jPanelTabGenus.add( jScrollPane1, java.awt.BorderLayout.CENTER );

        jMainPanel.add( jTabbedPane,java.awt.BorderLayout.CENTER );
        getContentPane().add( jMainPanel, java.awt.BorderLayout.CENTER );

        jMenuBar.add( jMenuFile );
        setJMenuBar( jMenuBar );
    }
    //--------------------------------------------------------------------------
    // Convert orgi. Checklist to XML_Checklist
    //--------------------------------------------------------------------------
    private void jMenuItemConvertToXmlActionPerformed (java.awt.event.ActionEvent evt)
    {
        logger.info( "Convert checklist" );
        // Read original Checklist and convert it to XML-Checklist
	JFileChooser chooser = new JFileChooser();
        chooser.setFileFilter( new ChecklistFileFilter() );
	int ret = chooser.showDialog( null, "Convert checklist" );
        if( ret == JFileChooser.APPROVE_OPTION ) 
        {
            String fullpath = chooser.getSelectedFile().getPath();
            String msg = "Convert checklist from file: " + fullpath;
            logger.info( msg );
            DnOptionPane.showMessageDialog( null, msg, "Information", DnOptionPane.INFORMATION_MESSAGE );

            ChecklistFileName importFilename = new ChecklistFileName( fullpath );                

            ImportDataFile idf = new ImportDataFile();

            idf.convertToXmlFile( importFilename );                
        }
        else
        {
            logger.info( "Abort convert checklist" );
        }
        return;
    }
    //--------------------------------------------------------------------------
    // Import Checklist
    //--------------------------------------------------------------------------
    private void jMenuItemImportActionPerformed (java.awt.event.ActionEvent evt)
    {
        logger.info( "checklist import" );
        // Read original XML Checklist and insert into database
        JFileChooser chooser = new JFileChooser();
        chooser.setFileFilter( new ChecklistFileFilter() );
	int ret = chooser.showDialog( this, "checklist import" );
       
        if( ret == JFileChooser.APPROVE_OPTION ) 
        {
            String fullpath = chooser.getSelectedFile().getPath();
            String msg = "Import checklist from file: " + fullpath;
            logger.info( msg );
            DnOptionPane.showMessageDialog( null, msg, "Information", DnOptionPane.INFORMATION_MESSAGE );
            StringBuffer importFileName = new StringBuffer();
            importFileName.append( fullpath );
            // read XML-Checklist
            XmlConfigurationImpl xmlData = new XmlConfigurationImpl( importFileName.toString() );
            xmlData.importChecklist( db );
        }    
        else
        {
            logger.info( "Abort import checklist from file" );
        }
	return;
    }
    //--------------------------------------------------------------------------
    // Import Checklists specified in a file list
    //--------------------------------------------------------------------------
    private void jMenuItemImportListActionPerformed (java.awt.event.ActionEvent evt)
    {
        logger.info( "Import a list of xml files" );
        // Read original XML Checklist and insert into database
        JFileChooser chooser = new JFileChooser();
	int ret = chooser.showDialog( null, "Import a list of xml files" );
        if( ret == JFileChooser.APPROVE_OPTION ) 
        {
            String fullpath = chooser.getSelectedFile().getPath();
            logger.info( "Import a list of xml files: " + fullpath  );
            String msg = "Import a list of xml files: " + fullpath;
            DnOptionPane.showMessageDialog( null, msg, "Information", DnOptionPane.INFORMATION_MESSAGE );
            String filename = fullpath;
            //---------------
            // read list file
            //---------------                
            java.io.BufferedReader          input     = null;    
            try
            {
                try
                {
                    input = new java.io.BufferedReader( new java.io.InputStreamReader( new java.io.FileInputStream( filename ), "UTF-8" ) );
                }
                catch( java.io.UnsupportedEncodingException ex )
                {
                    DnOptionPane.showMessageDialog( null, ex.toString(), "Error" , DnOptionPane.ERROR_MESSAGE );
                }
            }
            catch( java.io.FileNotFoundException ex )
            {
                msg = "File not found: " + filename + ":\n";
                DnOptionPane.showMessageDialog( null, msg, "Error", DnOptionPane.ERROR_MESSAGE );
            }

            try
            {
                while( input.ready() )
                {
                    String line = input.readLine();
                    if( line.trim().length() == 0 )
                    {
                        continue;
                    }
                    ChecklistFileName importFilename = new ChecklistFileName( line.trim() );

                    logger.info( "\nImport File: " + importFilename.getDefaultFilename() + "\n" );
                    //---------------------
                    // convert to xml file
                    //---------------------

                    ImportDataFile idf = new ImportDataFile();        

                    if( idf.convertToXmlFile( importFilename ) == false )
                    {
                        DnOptionPane.showMessageDialog( null, "There was an error when converting to xml file", "Error", DnOptionPane.ERROR_MESSAGE );
                        continue;
                    }
                    //---------------------
                    // read XML-Checklist
                    //---------------------                
                    XmlConfigurationImpl xmlData = new XmlConfigurationImpl( importFilename.getXmlFilename() );
                    xmlData.importChecklist( db );       
                }    
            }
            catch( Exception ex )
            {
                logger.error( "ex: " + ex.getMessage());
                DnOptionPane.showMessageDialog( null, ex.getMessage(), "Error", DnOptionPane.ERROR_MESSAGE );
            }
        }
        else
        {
            logger.info( "Abort import a list of xml files" );
        }
	return;
    }
    //--------------------------------------------------------------------------
    // Export
    //--------------------------------------------------------------------------
    private void jMenuItemExportActionPerformed (java.awt.event.ActionEvent evt)
    {
	// Export Checklist

	//	java.atw.FileDialog fd = new java.atw.FileDialog( null, "Import checklist " );

	logger.info( "Export" );
	JFileChooser chooser = new JFileChooser();
	chooser.showDialog( null, "Export checklist" );

	// Note: source for ExampleFileFilter can be found in FileChooserDemo,
	// under the demo/jfc directory in the Java 2 SDK, Standard Edition.
	/*
	ExampleFileFilter filter = new ExampleFileFilter();
	filter.addExtension("jpg");
	filter.addExtension("gif");
	filter.setDescription("JPG & GIF Images");
	chooser.setFileFilter(filter);
	int returnVal = chooser.showOpenDialog(parent);

	if(returnVal == JFileChooser.APPROVE_OPTION)
	{
	    logger.fatal( "You chose to open this file: " +  chooser.getSelectedFile().getName() );
	}
	*/
	return;
    }
    //--------------------------------------------------------------------------
    // Gis Data
    //--------------------------------------------------------------------------
    private void jMenuItemGisDataActionPerformed( java.awt.event.ActionEvent evt )
    {
	logger.info( "Save Gis Data" );
        // get output filename
        java.io.File file;            
        JFileChooser fc = new JFileChooser();
        fc.setDialogType( JFileChooser.SAVE_DIALOG );
        fc.setDialogTitle( "Grass Gis location list" );
        fc.setFileSelectionMode( JFileChooser.FILES_ONLY );
        int ret = fc.showSaveDialog( this );
        if( ret == JFileChooser.APPROVE_OPTION ) 
        {
            String fullpath = fc.getSelectedFile().getPath();
            logger.info( "Write file: " + fullpath +" ..." );
            StringBuffer data = null; 
            try
            {
                data = db.readGisData();
            }
            catch( java.sql.SQLException ex )
            {
                logger.error( ex.getMessage(), ex.fillInStackTrace() );            
            }

            WriteUnicodeFile wuf = new WriteUnicodeFile( fullpath, data.toString() );
            logger.info( "finish" );
        }				        
	return;
    }
    //--------------------------------------------------------------------------
    // Gis Cross Data
    //--------------------------------------------------------------------------
    private void jMenuItemGisCrossDataActionPerformed( java.awt.event.ActionEvent evt )
    {
	logger.info( "Save Gis Cross Data" );
        // get output filename
        java.io.File file;            
        JFileChooser fc = new JFileChooser();
        fc.setDialogType( JFileChooser.SAVE_DIALOG );
        fc.setDialogTitle( "Grass Gis cross location list" );
        fc.setFileSelectionMode( JFileChooser.FILES_ONLY );
        int ret = fc.showSaveDialog( this );
        if( ret == JFileChooser.APPROVE_OPTION ) 
        {
            String fullpath = fc.getSelectedFile().getPath();
            logger.info( "Write file: " + fullpath +" ..." );
            StringBuffer data = null;
            try
            {
                data = db.readGisCrossData();
            }
            catch( java.sql.SQLException ex )
            {
                logger.error( ex.getMessage(), ex.fillInStackTrace() );            
            }
            WriteUnicodeFile wuf = new WriteUnicodeFile( fullpath, data.toString() );
            logger.info( "finish" );
        }				        
	return;
    }
    
    private void jMenuItemExitActionPerformed( java.awt.event.ActionEvent evt )
    {
	this.setVisible( false );
    }
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt)
    {
        System.exit (0);
    }
    /**
    * @param args the command line arguments
    */
    public static void main( String args[] )
    {
        javax.swing.JFrame f = new javax.swing.JFrame(); 
        
        mainFrame = new ChecklistsMainFrame();
  
        mainFrame.setSize( 800,600 );
        mainFrame.setLocation( frameXpos, frameYpos );
        f.getContentPane().add( mainFrame );
        mainFrame.show();

        // Welche fonts gibt es ?
        /*
        java.awt.GraphicsEnvironment ge = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment();        
        java.awt.Font fo[] = ge.getAllFonts();        
        for( int i = 0; i < fo.length; i++ )
        {
            System.out.println( fo[ i ].getFamily() + " : " + fo[ i ].getFontName() + " : " + fo[ i ].getName() );
        }
        */
        
        /***********************************************************************
        // Unicode out stream        
        java.io.OutputStreamWriter uniOut = new java.io.OutputStreamWriter( System.out );        
        for( int i = 0x0300; i < 0x0400; i++ )
        {
            String hex = Integer.toHexString( i ) ;
            String str;
            switch( hex.length() )
            {
                case 1: str = "\\u000" + hex;
                        break;
                case 2: str = "\\u00" + hex;
                        break;
                case 3: str = "\\u0" + hex;
                        break;
                case 4: str = "\\u" + hex;
                        break;
                default:
                        str = "null";
                        break;  
            }
            Character ch = new Character( '#' );
            ch = new Character( Character.forDigit( i, 10 ) );
            // System.out.println( "str: " + str + " " + ch )"
            
            char    numChar = ch.forDigit( i, 10 );
            int     num;
            
            numChar = (char) i;
            num = numChar;
            try
            {
                uniOut.write( "str: " + num + " " + str + " " + ch.toString() + " " + numChar + " \n" );                
                uniOut.flush();
                // jTextArea1.setVisible( true );
                // jTextArea1.setText( "Output:\n" );
                // jTextArea1.append( "str: " + num + " " + str + " " + ch.toString() + " " + numChar + " \n"  );
                mainFrame.jTextAreaError.append( "str: " + num + " " + str + " " + ch.toString() + " " + numChar + " \n"  );
            }
            catch( java.io.IOException e )
            {
                System.out.println( "Can't write output" );
                e.printStackTrace();
            }
        }
        ***********************************************************************/
    }

}
