/*
 * CreateAcceptedTaxonID.java
 *
 * Created on 28. Juni 2004, 10:19
 */

package net.metadiversity.diversity.navigator.db.diversity_names_lias;

import java.lang.Integer;

/**
 *
 * @author  didi
 */
public class CreateAcceptedTaxonID
{
    final boolean debugFlag = false;
    
    java.lang.String db_url     = "jdbc:postgresql://hongkong.didi.dn:5432/ImportNames";
    java.lang.String db_user    = "didi";
    java.lang.String db_pwd     = "********";
    java.lang.String db_driver  = "org.postgresql.Driver";
    
    String databaseTable = "\"checklists_data\"";    
    String sql;
   
    java.util.Vector idVector;
    java.util.Vector acceptedIdVector;
    java.util.Vector basionymIdVector;
   
    java.util.Vector synVector;
    java.util.Vector firstVector;
    java.util.Vector authorVector;
    
    // data field names (for table checklists_data )
    
    final static String col_id              = "id";
    final static String col_ChecklistId     = "\"ChecklistId\"";
    final static String col_Unit            = "\"Unit\"";
    final static String col_Entry           = "\"Entry\"";
    
    final static String col_First           = "\"First\"";
    final static String col_Author          = "\"Author\"";
    
    final static String col_SynLevel        = "\"SynLevel\"";
    
    final static String col_AcceptedNameID  = "\"AcceptedNameID\"";
    final static String col_BasionymID      = "\"BasionymID\"";
    
    /** Creates a new instance of CreateAcceptedTaxonID */
    public CreateAcceptedTaxonID()
    {
        sql = "SELECT " + col_id + ", " +
                          col_ChecklistId + ", " +
                          col_Unit + ", " +
                          col_Entry + ", " +
                          col_First + ", " +
                          col_Author + ", " +
                          col_SynLevel +
               " FROM " + databaseTable + 
               " ORDER BY " + col_ChecklistId + ", " +
                              col_Unit + ", " +
                              col_Entry; 
        
        System.out.print( sql );

        java.sql.Connection con;
        java.sql.Statement  s;
        java.sql.ResultSet  res;
        
        acceptedIdVector = new java.util.Vector();
        basionymIdVector = new java.util.Vector();
        idVector = new java.util.Vector();
        
        try
        {
            Class.forName( "org.postgresql.Driver" );
            System.out.println( "Load PostgreSQL Driver..." );
        }
        catch( java.lang.ClassNotFoundException ee )
        {
            System.out.println( "ClassNotFoundException: " );
            System.out.println( ee.getMessage() );
        }
        try
        {
            con = java.sql.DriverManager.getConnection( db_url, db_user, db_pwd );
            
            s = con.createStatement();
            res = s.executeQuery( sql );

            int counter = 0;
            int id;
            int checklistId;
            int unit;
            int entry;
            String first;
            String author;
            int synLevel;
            
            int acceptedId = 0;
            int basionymId = -1;
            
            int vectorIndex = 0;
            
            java.util.Vector basionymVector = new java.util.Vector();
            
            while( res.next() )
            {
                // id
                id = res.getInt( 1 );                
                // Checklist_Id
                checklistId = res.getInt( 2 );
                // unit
                unit = res.getInt( 3 );                
                // entry
                entry = res.getInt( 4 );
                // System.out.println( counter++ + ", " +id + ", " + checklistId + ", " + unit + ", " + entry );
            
                first = res.getString( 5 );     // col_First );
                author = res.getString( 6 );    // col_Author );
                
                synLevel = res.getInt( 7 );     // col_SynLevel );
                
                if( debugFlag )
                {
                    System.out.println( "Result Index: " + vectorIndex + " id " + id );
                }
                if( entry == 1 || synLevel == 0 || synLevel == 1 || synLevel == 2 )
                {
                    basionymVector = new java.util.Vector();
                }
                
                class Basionym
                {
                    public String first;
                    public String author;
                    public int    id;
                    public int    synLevel;
                    public int    vectorIndex;
                    
                    public Basionym( int vectorIndex, int id, int synLevel, String first, String author )
                    {
                        this.id = id;
                        this.vectorIndex = vectorIndex;
                        this.synLevel = synLevel;
                        this.first = first;
                        this.author = author;
                    }
                };
                
                basionymVector.add( new Basionym( vectorIndex, id, synLevel, first, author ) );
                
                if( entry == 1 )
                {
                    acceptedId = id;
                    idVector.add( new Integer( acceptedId ) );
                    acceptedIdVector.add(  new Integer( acceptedId ) );
                    // System.out.println( counter++ + ", " +id + ", " + checklistId + ", " + unit + ", " + entry );                    

                    // Basionym
                    
                    if( first == null || first.trim().length() == 0 )
                    {
                        basionymIdVector.add( new Integer( id ) );
                    }
                    else
                    {
                        basionymIdVector.add( new Integer( -1 ) );
                    }                                        
                }
                else
                {
                    idVector.add(  new Integer( id ) );
                    acceptedIdVector.add( new Integer( acceptedId ) );
                    //
                    // build up BasionymID
                    //

                    if( ( synLevel == 1 || synLevel == 2 ) && ( first == null || first.trim().length() == 0 ) )
                    {
                        basionymIdVector.add( new Integer( id ) );
                    }
                    else
                    {
                        basionymIdVector.add( new Integer( -1 ) );
                    }                  
                    
                    if( synLevel == 3 )                                              
                    {
                        int basionymID = -1;
                        // find basionym ID                       
                        for( int i = 0; i < basionymVector.size(); i++ )
                        {
                            Basionym b = (Basionym) basionymVector.get( i );
                            
                            if( b.first == null || b.first.trim().length() == 0 )
                            {
                                basionymID = b.id;
                            }
                        }
                        // set basionymID
                        if( debugFlag )
                        {
                            System.out.println( "basionymIdVector.size() " + basionymIdVector.size() );
                        }
                        for( int i = 0; i < basionymVector.size(); i++ )
                        {
                            Basionym b = (Basionym) basionymVector.get( i );
                            basionymIdVector.set( b.vectorIndex, new Integer( basionymID ) ); 
                        }                        
                    }
                }
                vectorIndex++;
            }
            //
            // Insert Accepted TaxonID and BasionymID
            //
            for( int i = 0; i < idVector.size(); i++ )
            {
                int iid     = ((Integer) idVector.get( i )).intValue();
                int aid     = ((Integer) acceptedIdVector.get( i )).intValue();
                int bid     = ((Integer) basionymIdVector.get( i )).intValue();
                
                if( iid != aid )
                {
                    // System.out.println( "Insert AcceptedNameID : " + iid + ",  " + aid );
                }
                sql = "UPDATE " + databaseTable + 
                      " SET " + col_AcceptedNameID + " = " + aid + " , " +
                                col_BasionymID + " = " + bid + 
                      " WHERE " + col_id + " = " + iid;
                if( debugFlag )
                {
                    System.out.println( sql );
                }
                else
                {
                    s.executeUpdate( sql );
                }
            }
            con.close(); 
            System.out.println( "finish" );
        }            
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getMessage() );             
        }        
    }
    
    
    
    //--------------------------------------------------------------------------
    public static void main(String[] args)
    {
        // only for testing
        CreateAcceptedTaxonID catid = new CreateAcceptedTaxonID();
        
        
    }

}
