/*
 * CollectionTabIndentification.java
 *
 * Created on 15. September 2004, 11:39
 */

package net.metadiversity.diversity.navigator.gui;

import com.jgoodies.forms.layout.*;
import com.jgoodies.forms.layout.ColumnSpec;

import net.metadiversity.diversity.navigator.db.ub.DnDataRecordSelector;
/**
 *
 * @author  didi
 */
public class CollectionTabMiscellaneous extends com.jgoodies.forms.builder.PanelBuilder
{
    com.jgoodies.forms.builder.PanelBuilder     builder;
    // default format values
    static final String DEFAULT_COLUMNE_FORMAT = "fill:d:grow";
    static final String PAD_COLUMNE_FORMAT     = "fill:3dlu:nogrow";
    static final String DEFAULT_ROW_FORMAT     = "fill:d:nogrow";
    static final String PAD_ROW_FORMAT         = "fill:3dlu:nogrow";    
    // Form parameter
    int xMaxFormPos;
    int yMaxFormPos;
    // debug
    boolean DEBUG_ADD_COMPONENT = false;
    boolean DEBUG_LINE_AND_ROW_NUMBERS = false;
    //
    CellConstraints cc;
    //
    public DnDataRecordSelector        storageRecords;
    public DnDataRecordSelector        duplicateRecords;
    
    public void showLineNumbers( boolean b )
    {
        DEBUG_LINE_AND_ROW_NUMBERS = b;
    }
    
    public CollectionTabMiscellaneous()
    {
        super( new com.jgoodies.forms.layout.FormLayout( "", "" ) );
        showLineNumbers( false );
        cc = new CellConstraints();
        xMaxFormPos = 15;
        yMaxFormPos = 8;
        
        ColumnSpec colPad = new com.jgoodies.forms.layout.ColumnSpec( PAD_COLUMNE_FORMAT );              
        ColumnSpec colDef = new com.jgoodies.forms.layout.ColumnSpec( DEFAULT_COLUMNE_FORMAT );              
        
        RowSpec rowPad = new com.jgoodies.forms.layout.RowSpec( PAD_ROW_FORMAT );              
        RowSpec rowDef = new com.jgoodies.forms.layout.RowSpec( DEFAULT_ROW_FORMAT );              

        
        if( DEBUG_LINE_AND_ROW_NUMBERS )
        {
            appendColumn( colDef );
            appendRow( rowDef );
        }
        else
        {
            appendColumn( colPad );
            appendRow( rowPad );                
        }
        
        for( int col = 1; col <= xMaxFormPos; col++ )
        {
            appendColumn( colDef );
            if( DEBUG_LINE_AND_ROW_NUMBERS && col == xMaxFormPos )
            {
                appendColumn( colDef );
            }
            else
            {
                appendColumn( colPad );
            }
        }
        for( int row = 1; row <= yMaxFormPos; row++ )
        {   
            appendRow( rowDef );
            if( DEBUG_LINE_AND_ROW_NUMBERS && row == yMaxFormPos )
            {
                appendRow( rowDef );
            }
            else
            {
                appendRow( rowPad );                   
            }
            if( DEBUG_LINE_AND_ROW_NUMBERS )
            {
                // Set line numbers 
                javax.swing.JLabel l1 = new javax.swing.JLabel( String.valueOf( row ) );
                add( l1, cc.xy( 1 , row * 2 ) );
                javax.swing.JLabel l2 = new javax.swing.JLabel( String.valueOf( row ) );
                add( l2, cc.xy( xMaxFormPos * 2 + 1, row * 2 ) );
            }
            else
            {
                javax.swing.JLabel l1 = new javax.swing.JLabel( " " );
                add( l1, cc.xy( 1 , row * 2 ) );                
            }
        }
        
        for( int col = 1; col <= xMaxFormPos; col++ )
        {
            if( DEBUG_LINE_AND_ROW_NUMBERS )
            {
                // set column numbers
                javax.swing.JLabel l1 = new javax.swing.JLabel( String.valueOf( col ) );
                add( l1, cc.xy( col * 2, 1 ) );
                javax.swing.JLabel l2 = new javax.swing.JLabel( String.valueOf( col ) );
                add( l2, cc.xy( col * 2, yMaxFormPos * 2 + 1 ) );
            }
        }
        //----------------------------------------------------------------------
        // Change Layout for "Date"
        //----------------------------------------------------------------------
        int dateStartPos = 16;
        
        com.jgoodies.forms.layout.FormLayout layout = getLayout();
        
        if( ! DEBUG_LINE_AND_ROW_NUMBERS )
        {
            // !!! remove / add columns from the right side !!!
            // dd
            layout.removeColumn( dateStartPos +  0 );
            layout.insertColumn( dateStartPos +  0, new com.jgoodies.forms.layout.ColumnSpec( "fill:12dlu:nogrow" ) );
            // mm
            layout.removeColumn( dateStartPos +  2 );
            layout.insertColumn( dateStartPos +  2, new com.jgoodies.forms.layout.ColumnSpec( "fill:12dlu:nogrow" ) );
            // yyyy
            layout.removeColumn( dateStartPos +  4 );
            layout.insertColumn( dateStartPos +  4, new com.jgoodies.forms.layout.ColumnSpec( "fill:20dlu:nogrow" ) );
        }
        
        //----------------------------------------------------------------------
        
        addSeparator( "Storage location", cc.xywh( 2, 2, 5, 1 ) );
        addSeparator( "Exsiccate", cc.xywh( 10, 2, 19, 1 ) );
        addSeparator( "Duplicates", cc.xywh( 2, 10, 5, 1 ) );
        addSeparator( "Accession", cc.xywh( 10, 6, 19, 1 ) );
        addSeparator( "Borrow & loan", cc.xywh( 10, 12, 19, 1 ) );
        
        //----------------------------------------------------------------------
        // Add Record selector for Storage and Duplicate
        //----------------------------------------------------------------------
        storageRecords  = new DnDataRecordSelector();
        duplicateRecords   = new DnDataRecordSelector();
        
        java.awt.GridBagConstraints gridBagConstraints;
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 3;
        add( storageRecords, gridBagConstraints );
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 3;
        add( duplicateRecords, gridBagConstraints );
            
        initComponents();                
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void debug( int x, int y, int l, int h )
    {
        System.out.println( "x: " + x +  " \ty: " + y + " \tl:" + l );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void setLayout( java.awt.LayoutManager lm )
    {
        
    }
    void add( javax.swing.JComponent c, java.awt.GridBagConstraints gbc )    
    {
        cc = new CellConstraints();
        System.out.println( c );
        // Don't show Lable outside the form
        if( gbc.gridx > xMaxFormPos || gbc.gridy > yMaxFormPos )
        {
            return;
        }
        cc.xywh( ( gbc.gridx + 1 ) * 2, ( gbc.gridy + 1 ) * 2, ( gbc.gridwidth * 2 ) -1, ( gbc.gridheight * 2 ) -1 );
        System.out.println( cc );        
        add( c, cc );
        
    }
    /** This method is called from within the constructor to     
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabelStorageLocation = new javax.swing.JLabel();
        jLabelCollection = new javax.swing.JLabel();
        jComboBoxCollection = new javax.swing.JComboBox();
        jLabelStorageLocationE_G = new javax.swing.JLabel();
        jTextFieldStorageLocationE_G = new javax.swing.JTextField();
        jLabelMaterialCategory = new javax.swing.JLabel();
        jComboBoxMaterialCategory = new javax.swing.JComboBox();
        jLabelDuplicates = new javax.swing.JLabel();
        jLabelAccessionNumber = new javax.swing.JLabel();
        jLabelDuplicatesNotes = new javax.swing.JLabel();
        jLabelDuplicatesCollection = new javax.swing.JLabel();
        jComboBoxDuplicatesCollection = new javax.swing.JComboBox();
        jTextFieldAccessionNumber = new javax.swing.JTextField();
        jTextFieldDuplicatesNotes = new javax.swing.JTextField();
        jLabelExsicAbbrev = new javax.swing.JLabel();
        jTextFieldExsicAbbrev = new javax.swing.JTextField();
        jLabelExsicNr = new javax.swing.JLabel();
        jTextFieldExsicNr = new javax.swing.JTextField();
        jCheckBoxIsExsccate = new javax.swing.JCheckBox();
        jLabelAccessionNr = new javax.swing.JLabel();
        jTextFieldAccessionNr = new javax.swing.JTextField();
        jLabelDate = new javax.swing.JLabel();
        jTextFieldDateDD = new javax.swing.JTextField();
        jTextFieldDateMM = new javax.swing.JTextField();
        jTextFieldDateYYYY = new javax.swing.JTextField();
        jLabelDateSup = new javax.swing.JLabel();
        jTextFieldDateSup = new javax.swing.JTextField();
        jLabelDateCategory = new javax.swing.JLabel();
        jComboBoxDateCategory = new javax.swing.JComboBox();
        jScrollPaneBorrowLoan = new javax.swing.JScrollPane();
        jTextPaneBorrowLoan = new javax.swing.JTextPane();
        jLabelDepositorName = new javax.swing.JLabel();
        jComboBoxDepositorName = new javax.swing.JComboBox();
        jLabelDepositorNr = new javax.swing.JLabel();
        jTextFieldDepositorNr = new javax.swing.JTextField();

        setLayout(new java.awt.GridBagLayout());

        jLabelStorageLocation.setText("StorageLocation");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        add(jLabelStorageLocation, gridBagConstraints);

        jLabelCollection.setText("Collection");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        add(jLabelCollection, gridBagConstraints);

        jComboBoxCollection.setEditable(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        add(jComboBoxCollection, gridBagConstraints);

        jLabelStorageLocationE_G.setText("StorageLocation (e. g. tax. name)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        add(jLabelStorageLocationE_G, gridBagConstraints);

        jTextFieldStorageLocationE_G.setText("StorageLocation");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        add(jTextFieldStorageLocationE_G, gridBagConstraints);

        jLabelMaterialCategory.setText("MaterialCategory");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        add(jLabelMaterialCategory, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        add(jComboBoxMaterialCategory, gridBagConstraints);

        jLabelDuplicates.setText("Duplicates");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        add(jLabelDuplicates, gridBagConstraints);

        jLabelAccessionNumber.setText("AccessionNumber");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        add(jLabelAccessionNumber, gridBagConstraints);

        jLabelDuplicatesNotes.setText("Notes");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        add(jLabelDuplicatesNotes, gridBagConstraints);

        jLabelDuplicatesCollection.setText("Collection");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        add(jLabelDuplicatesCollection, gridBagConstraints);

        jComboBoxDuplicatesCollection.setEditable(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        add(jComboBoxDuplicatesCollection, gridBagConstraints);

        jTextFieldAccessionNumber.setText("AccessionNumber");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        add(jTextFieldAccessionNumber, gridBagConstraints);

        jTextFieldDuplicatesNotes.setText("DuplicatesNotes");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 6;
        add(jTextFieldDuplicatesNotes, gridBagConstraints);

        jLabelExsicAbbrev.setText("Exsic. abbrev.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
        add(jLabelExsicAbbrev, gridBagConstraints);

        jTextFieldExsicAbbrev.setText("jTextField1");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        add(jTextFieldExsicAbbrev, gridBagConstraints);

        jLabelExsicNr.setText("No.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 1;
        add(jLabelExsicNr, gridBagConstraints);

        jTextFieldExsicNr.setText("ExsicNr");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 10;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        add(jTextFieldExsicNr, gridBagConstraints);

        jCheckBoxIsExsccate.setText("Is Exsccate");
        jCheckBoxIsExsccate.setActionCommand("Is Exsiccate");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 12;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        add(jCheckBoxIsExsccate, gridBagConstraints);

        jLabelAccessionNr.setText("Accession No.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 3;
        add(jLabelAccessionNr, gridBagConstraints);

        jTextFieldAccessionNr.setText("AccessionNr");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 3;
        add(jTextFieldAccessionNr, gridBagConstraints);

        jLabelDate.setText("Date (d|m|y)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 3;
        add(jLabelDate, gridBagConstraints);

        jTextFieldDateDD.setText("dd");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 3;
        add(jTextFieldDateDD, gridBagConstraints);

        jTextFieldDateMM.setText("mm");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 8;
        gridBagConstraints.gridy = 3;
        add(jTextFieldDateMM, gridBagConstraints);

        jTextFieldDateYYYY.setText("yyyy");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 3;
        add(jTextFieldDateYYYY, gridBagConstraints);

        jLabelDateSup.setText("sup.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 10;
        gridBagConstraints.gridy = 3;
        add(jLabelDateSup, gridBagConstraints);

        jTextFieldDateSup.setText("DateSup");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 11;
        gridBagConstraints.gridy = 3;
        add(jTextFieldDateSup, gridBagConstraints);

        jLabelDateCategory.setText("cat.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 12;
        gridBagConstraints.gridy = 3;
        add(jLabelDateCategory, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 13;
        gridBagConstraints.gridy = 3;
        add(jComboBoxDateCategory, gridBagConstraints);

        jTextPaneBorrowLoan.setText("BorrowLoan");
        jScrollPaneBorrowLoan.setViewportView(jTextPaneBorrowLoan);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 10;
        gridBagConstraints.gridheight = 2;
        add(jScrollPaneBorrowLoan, gridBagConstraints);

        jLabelDepositorName.setText("Depositor name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 4;
        add(jLabelDepositorName, gridBagConstraints);

        jComboBoxDepositorName.setEditable(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 4;
        add(jComboBoxDepositorName, gridBagConstraints);

        jLabelDepositorNr.setText("No.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 4;
        add(jLabelDepositorNr, gridBagConstraints);

        jTextFieldDepositorNr.setText("Depositor Nr");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 5;
        add(jTextFieldDepositorNr, gridBagConstraints);

    }//GEN-END:initComponents
    
    public static void main( String [] args  )
    {
        CollectionTabMiscellaneous p = new CollectionTabMiscellaneous();
        
        javax.swing.JFrame f = new javax.swing.JFrame();        
        f.getContentPane().add( p.getPanel() );
        f.setVisible( true );
        f.setDefaultCloseOperation( javax.swing.JFrame.DISPOSE_ON_CLOSE );
    }
    
    /**
     * Getter for property jTextFieldAccessionNr.
     * @return Value of property jTextFieldAccessionNr.
     */
    public javax.swing.JTextField getJTextFieldAccessionNr()
    {
        return jTextFieldAccessionNr;
    }    
    
    /**
     * Setter for property jTextFieldAccessionNr.
     * @param jTextFieldAccessionNr New value of property jTextFieldAccessionNr.
     */
    public void setJTextFieldAccessionNr(javax.swing.JTextField jTextFieldAccessionNr)
    {
        this.jTextFieldAccessionNr = jTextFieldAccessionNr;
    }
    
    /**
     * Getter for property jTextFieldAccessionNumber.
     * @return Value of property jTextFieldAccessionNumber.
     */
    public javax.swing.JTextField getJTextFieldAccessionNumber()
    {
        return jTextFieldAccessionNumber;
    }
    
    /**
     * Setter for property jTextFieldAccessionNumber.
     * @param jTextFieldAccessionNumber New value of property jTextFieldAccessionNumber.
     */
    public void setJTextFieldAccessionNumber(javax.swing.JTextField jTextFieldAccessionNumber)
    {
        this.jTextFieldAccessionNumber = jTextFieldAccessionNumber;
    }
    
    /**
     * Getter for property jTextFieldDateDD.
     * @return Value of property jTextFieldDateDD.
     */
    public javax.swing.JTextField getJTextFieldDateDD()
    {
        return jTextFieldDateDD;
    }
    
    /**
     * Setter for property jTextFieldDateDD.
     * @param jTextFieldDateDD New value of property jTextFieldDateDD.
     */
    public void setJTextFieldDateDD(javax.swing.JTextField jTextFieldDateDD)
    {
        this.jTextFieldDateDD = jTextFieldDateDD;
    }
    
    /**
     * Getter for property jTextFieldDateSup.
     * @return Value of property jTextFieldDateSup.
     */
    public javax.swing.JTextField getJTextFieldDateSup()
    {
        return jTextFieldDateSup;
    }
    
    /**
     * Setter for property jTextFieldDateSup.
     * @param jTextFieldDateSup New value of property jTextFieldDateSup.
     */
    public void setJTextFieldDateSup(javax.swing.JTextField jTextFieldDateSup)
    {
        this.jTextFieldDateSup = jTextFieldDateSup;
    }
    
    /**
     * Getter for property jTextFieldDateYYYY.
     * @return Value of property jTextFieldDateYYYY.
     */
    public javax.swing.JTextField getJTextFieldDateYYYY()
    {
        return jTextFieldDateYYYY;
    }
    
    /**
     * Setter for property jTextFieldDateYYYY.
     * @param jTextFieldDateYYYY New value of property jTextFieldDateYYYY.
     */
    public void setJTextFieldDateYYYY(javax.swing.JTextField jTextFieldDateYYYY)
    {
        this.jTextFieldDateYYYY = jTextFieldDateYYYY;
    }
    
    /**
     * Getter for property jTextFieldDepositorNr.
     * @return Value of property jTextFieldDepositorNr.
     */
    public javax.swing.JTextField getJTextFieldDepositorNr()
    {
        return jTextFieldDepositorNr;
    }
    
    /**
     * Setter for property jTextFieldDepositorNr.
     * @param jTextFieldDepositorNr New value of property jTextFieldDepositorNr.
     */
    public void setJTextFieldDepositorNr(javax.swing.JTextField jTextFieldDepositorNr)
    {
        this.jTextFieldDepositorNr = jTextFieldDepositorNr;
    }
    
    /**
     * Getter for property jTextFieldDuplicatesNotes.
     * @return Value of property jTextFieldDuplicatesNotes.
     */
    public javax.swing.JTextField getJTextFieldDuplicatesNotes()
    {
        return jTextFieldDuplicatesNotes;
    }
    
    /**
     * Setter for property jTextFieldDuplicatesNotes.
     * @param jTextFieldDuplicatesNotes New value of property jTextFieldDuplicatesNotes.
     */
    public void setJTextFieldDuplicatesNotes(javax.swing.JTextField jTextFieldDuplicatesNotes)
    {
        this.jTextFieldDuplicatesNotes = jTextFieldDuplicatesNotes;
    }
    
    /**
     * Getter for property jTextFieldExsicAbbrev.
     * @return Value of property jTextFieldExsicAbbrev.
     */
    public javax.swing.JTextField getJTextFieldExsicAbbrev()
    {
        return jTextFieldExsicAbbrev;
    }
    
    /**
     * Setter for property jTextFieldExsicAbbrev.
     * @param jTextFieldExsicAbbrev New value of property jTextFieldExsicAbbrev.
     */
    public void setJTextFieldExsicAbbrev(javax.swing.JTextField jTextFieldExsicAbbrev)
    {
        this.jTextFieldExsicAbbrev = jTextFieldExsicAbbrev;
    }
    
    /**
     * Getter for property jTextFieldExsicNr.
     * @return Value of property jTextFieldExsicNr.
     */
    public javax.swing.JTextField getJTextFieldExsicNr()
    {
        return jTextFieldExsicNr;
    }
    
    /**
     * Setter for property jTextFieldExsicNr.
     * @param jTextFieldExsicNr New value of property jTextFieldExsicNr.
     */
    public void setJTextFieldExsicNr(javax.swing.JTextField jTextFieldExsicNr)
    {
        this.jTextFieldExsicNr = jTextFieldExsicNr;
    }
    
    /**
     * Getter for property jTextFieldStorageLocationE_G.
     * @return Value of property jTextFieldStorageLocationE_G.
     */
    public javax.swing.JTextField getJTextFieldStorageLocationE_G()
    {
        return jTextFieldStorageLocationE_G;
    }
    
    /**
     * Setter for property jTextFieldStorageLocationE_G.
     * @param jTextFieldStorageLocationE_G New value of property jTextFieldStorageLocationE_G.
     */
    public void setJTextFieldStorageLocationE_G(javax.swing.JTextField jTextFieldStorageLocationE_G)
    {
        this.jTextFieldStorageLocationE_G = jTextFieldStorageLocationE_G;
    }
    
    /**
     * Getter for property jTextPaneBorrowLoan.
     * @return Value of property jTextPaneBorrowLoan.
     */
    public javax.swing.JTextPane getJTextPaneBorrowLoan()
    {
        return jTextPaneBorrowLoan;
    }
    
    /**
     * Setter for property jTextPaneBorrowLoan.
     * @param jTextPaneBorrowLoan New value of property jTextPaneBorrowLoan.
     */
    public void setJTextPaneBorrowLoan(javax.swing.JTextPane jTextPaneBorrowLoan)
    {
        this.jTextPaneBorrowLoan = jTextPaneBorrowLoan;
    }
    
    /**
     * Getter for property jTextFieldDateMM.
     * @return Value of property jTextFieldDateMM.
     */
    public javax.swing.JTextField getJTextFieldDateMM()
    {
        return jTextFieldDateMM;
    }
    
    /**
     * Setter for property jTextFieldDateMM.
     * @param jTextFieldDateMM New value of property jTextFieldDateMM.
     */
    public void setJTextFieldDateMM(javax.swing.JTextField jTextFieldDateMM)
    {
        this.jTextFieldDateMM = jTextFieldDateMM;
    }
    
    /**
     * Getter for property jCheckBoxIsExsccate.
     * @return Value of property jCheckBoxIsExsccate.
     */
    public javax.swing.JCheckBox getJCheckBoxIsExsccate()
    {
        return jCheckBoxIsExsccate;
    }
    
    /**
     * Setter for property jCheckBoxIsExsccate.
     * @param jCheckBoxIsExsccate New value of property jCheckBoxIsExsccate.
     */
    public void setJCheckBoxIsExsccate(javax.swing.JCheckBox jCheckBoxIsExsccate)
    {
        this.jCheckBoxIsExsccate = jCheckBoxIsExsccate;
    }
    
    /**
     * Getter for property jComboBoxCollection.
     * @return Value of property jComboBoxCollection.
     */
    public javax.swing.JComboBox getJComboBoxCollection()
    {
        return jComboBoxCollection;
    }
    
    /**
     * Setter for property jComboBoxCollection.
     * @param jComboBoxCollection New value of property jComboBoxCollection.
     */
    public void setJComboBoxCollection(javax.swing.JComboBox jComboBoxCollection)
    {
        this.jComboBoxCollection = jComboBoxCollection;
    }
    
   
    /**
     * Getter for property jComboBoxDepositorName.
     * @return Value of property jComboBoxDepositorName.
     */
    public javax.swing.JComboBox getJComboBoxDepositorName()
    {
        return jComboBoxDepositorName;
    }
    
    /**
     * Setter for property jComboBoxDepositorName.
     * @param jComboBoxDepositorName New value of property jComboBoxDepositorName.
     */
    public void setJComboBoxDepositorName(javax.swing.JComboBox jComboBoxDepositorName)
    {
        this.jComboBoxDepositorName = jComboBoxDepositorName;
    }
    
    /**
     * Getter for property jComboBoxDuplicatesCollection.
     * @return Value of property jComboBoxDuplicatesCollection.
     */
    public javax.swing.JComboBox getJComboBoxDuplicatesCollection()
    {
        return jComboBoxDuplicatesCollection;
    }
    
    /**
     * Setter for property jComboBoxDuplicatesCollection.
     * @param jComboBoxDuplicatesCollection New value of property jComboBoxDuplicatesCollection.
     */
    public void setJComboBoxDuplicatesCollection(javax.swing.JComboBox jComboBoxDuplicatesCollection)
    {
        this.jComboBoxDuplicatesCollection = jComboBoxDuplicatesCollection;
    }
    
    /**
     * Getter for property jComboBoxDateCategory.
     * @return Value of property jComboBoxDateCategory.
     */
    public javax.swing.JComboBox getJComboBoxDateCategory()
    {
        return jComboBoxDateCategory;
    }
    
    /**
     * Setter for property jComboBoxDateCategory.
     * @param jComboBoxDateCategory New value of property jComboBoxDateCategory.
     */
    public void setJComboBoxDateCategory(javax.swing.JComboBox jComboBoxDateCategory)
    {
        this.jComboBoxDateCategory = jComboBoxDateCategory;
    }
    
    /**
     * Getter for property jComboBoxMaterialCategory.
     * @return Value of property jComboBoxMaterialCategory.
     */
    public javax.swing.JComboBox getJComboBoxMaterialCategory()
    {
        return jComboBoxMaterialCategory;
    }
    
    /**
     * Setter for property jComboBoxMaterialCategory.
     * @param jComboBoxMaterialCategory New value of property jComboBoxMaterialCategory.
     */
    public void setJComboBoxMaterialCategory(javax.swing.JComboBox jComboBoxMaterialCategory)
    {
        this.jComboBoxMaterialCategory = jComboBoxMaterialCategory;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox jCheckBoxIsExsccate;
    private javax.swing.JComboBox jComboBoxCollection;
    private javax.swing.JComboBox jComboBoxDateCategory;
    private javax.swing.JComboBox jComboBoxDepositorName;
    private javax.swing.JComboBox jComboBoxDuplicatesCollection;
    private javax.swing.JComboBox jComboBoxMaterialCategory;
    private javax.swing.JLabel jLabelAccessionNr;
    private javax.swing.JLabel jLabelAccessionNumber;
    private javax.swing.JLabel jLabelCollection;
    private javax.swing.JLabel jLabelDate;
    private javax.swing.JLabel jLabelDateCategory;
    private javax.swing.JLabel jLabelDateSup;
    private javax.swing.JLabel jLabelDepositorName;
    private javax.swing.JLabel jLabelDepositorNr;
    private javax.swing.JLabel jLabelDuplicates;
    private javax.swing.JLabel jLabelDuplicatesCollection;
    private javax.swing.JLabel jLabelDuplicatesNotes;
    private javax.swing.JLabel jLabelExsicAbbrev;
    private javax.swing.JLabel jLabelExsicNr;
    private javax.swing.JLabel jLabelMaterialCategory;
    private javax.swing.JLabel jLabelStorageLocation;
    private javax.swing.JLabel jLabelStorageLocationE_G;
    private javax.swing.JScrollPane jScrollPaneBorrowLoan;
    private javax.swing.JTextField jTextFieldAccessionNr;
    private javax.swing.JTextField jTextFieldAccessionNumber;
    private javax.swing.JTextField jTextFieldDateDD;
    private javax.swing.JTextField jTextFieldDateMM;
    private javax.swing.JTextField jTextFieldDateSup;
    private javax.swing.JTextField jTextFieldDateYYYY;
    private javax.swing.JTextField jTextFieldDepositorNr;
    private javax.swing.JTextField jTextFieldDuplicatesNotes;
    private javax.swing.JTextField jTextFieldExsicAbbrev;
    private javax.swing.JTextField jTextFieldExsicNr;
    private javax.swing.JTextField jTextFieldStorageLocationE_G;
    private javax.swing.JTextPane jTextPaneBorrowLoan;
    // End of variables declaration//GEN-END:variables
    
}
