package net.metadiversity.diversity.navigator.gui;

import org.apache.log4j.Logger;

import java.sql.*;
import java.util.ArrayList;
//import javax.swing.table.*;

/**
 *
 * @author  Dieter Neubacher
 */
/*
   Diese Klasse speichert die Daten der Ergebnismenge zwischen und
   eignet sich, wenn bildlauff�hige Cursor nicht unterst�tzt werden.
*/
class QueryCachingResultSetTableModel extends QueryResultSetTableModel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3978990980986581559L;

    static Logger logger = Logger.getLogger( QueryResultSetTableModel.class.getName() );

    private ArrayList cache;
   
    public QueryCachingResultSetTableModel(ResultSet aResultSet)
    {
        super( aResultSet );
        try
        {
            cache           = new ArrayList();
            int cols        = getColumnCount();
            ResultSet rs    = getResultSet();

            // Copy all Data into Arrayliste

            while( rs.next() )
            {
                Object[] row = new Object[cols];
                for( int j = 0; j < row.length; j++ )
                {
                    row[ j ] = rs.getObject( j + 1 );
                }
                cache.add( row );
            }
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
    }
    //---------------------------------------------------------------------------
    //---------------------------------------------------------------------------
    public Object getValueAt(int r, int c)
    {
        if( r < cache.size() )
        {
            return ( (Object[]) cache.get( r ) )[ c ];
        }
        else
        {
            return null;
        }
    }
    //---------------------------------------------------------------------------
    //---------------------------------------------------------------------------
    public int getRowCount()
    {
        return cache.size();
    }
}