/*
 * DeltaEditorTableCellRenderer.java
 *
 * Created on 9. Februar 2004, 16:04
 */

package net.metadiversity.diversity.navigator.gui.delta_editor;

import org.apache.log4j.Logger;

import net.metadiversity.diversity.navigator.db.delta_editor.CharacterStateDescription;
/**
 *
 * @author  didi
 */
//public class DeltaEditorTableCellRenderer implements javax.swing.table.TableCellRenderer 
public class DeltaEditorTableCellRenderer extends javax.swing.table.DefaultTableCellRenderer 
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3690752908371375412L;

    static Logger logger = Logger.getLogger( DeltaEditorTableCellRenderer.class.getName() );
    
    private javax.swing.JLabel label;
    private javax.swing.JLabel lastSelectedLabel;
    // GUI SETTINGS
    
    static java.awt.Color   backgroundInapplicalibleColor; 
    static java.awt.Color   backgroundInapplicalibleColorLight;
    static int              tableCellHorizontalAlignment;

    private int    lastSelectedCol;
    private int    lastSelectedRow; 
    
    /** Creates a new instance of DeltaEditorTableCellRenderer */
    public DeltaEditorTableCellRenderer() 
    {
        label = new javax.swing.JLabel();
    
        lastSelectedRow = -1;
        lastSelectedCol = -1;
        
        lastSelectedLabel = null;        
        
        if( true )
        {    
            backgroundInapplicalibleColor       = new java.awt.Color( 255, 192, 192 );   // use RGB -->  red 
            backgroundInapplicalibleColorLight  = new java.awt.Color( 255, 224, 224 );   // use RGB --> light red
            tableCellHorizontalAlignment        = javax.swing.SwingConstants.CENTER;
        }
        else
        {    
            backgroundInapplicalibleColor       = new java.awt.Color( 255, 128, 128 );   // use RGB -->  red 
            backgroundInapplicalibleColorLight  = new java.awt.Color( 255, 192, 192 );   // use RGB --> light red
            tableCellHorizontalAlignment        = javax.swing.SwingConstants.LEFT;
        }
    }
    
    public java.awt.Component getTableCellRendererComponent( javax.swing.JTable jTable, Object obj, boolean isSelected, boolean hasFocus, int row, int col ) 
    {
        // logger.debug( "DeltaEditor render component col: " + col + " row: " + row );
        label = new javax.swing.JLabel();
     
        if( row == -1 ) // Header
        {
            // System.out.println( "Header for: " + ( String ) obj );
            label.setText( ( String ) obj );
            // label.setBackground( java.awt.Color.BLUE );
            // label.setForeground( java.awt.Color.RED );
            label.setVerticalAlignment( javax.swing.SwingConstants.TOP );
            label.setHorizontalAlignment( javax.swing.SwingConstants.CENTER );
            label.setPreferredSize( new java.awt.Dimension( 80,80 ) ); 
            label.setBorder( new javax.swing.border.EtchedBorder() );
            return label;
        }
/***        
        if( isSelected && hasFocus )
        {
            if( lastSelectedRow != row || lastSelectedCol != col )
            {            
                // System.out.println( "LastSelected row: " + row + " col: " + col );
                if( lastSelectedLabel != null )
                {    
                    lastSelectedLabel.setOpaque( true );
                    lastSelectedLabel.setBackground( java.awt.Color.GREEN );
                    lastSelectedLabel.repaint();
                    lastSelectedLabel.setVisible( true );
                    System.out.println( "Repaint LastSelected row: " + lastSelectedRow + " col: " + lastSelectedCol );
                }
                lastSelectedLabel = label;        
                
                lastSelectedRow = row;
                lastSelectedCol = col;
            }
        }
***/        
        CharacterStateDescription csd = ( CharacterStateDescription ) obj;        
        if( csd.isInapplicalible() )
        {
            String str = csd.getTableCellText();
            if( str.length() == 0 )
            {               
                label.setText( "-" );
                label.setHorizontalAlignment( javax.swing.SwingConstants.CENTER );
            }
            else
            {
                label.setText( csd.getTableCellText() );
                label.setHorizontalAlignment( tableCellHorizontalAlignment );
            }
            label.setOpaque( true );
            label.setForeground( java.awt.Color.BLACK );
            if( isSelected )
            {
                if( hasFocus )
                {
                    // label.setBackground( backgroundInapplicalibleColorLight );
                    label.setBackground( java.awt.Color.LIGHT_GRAY );
                }
                else
                {
                    if( lastSelectedCol == col && lastSelectedRow == row )
                    {
                        // label.setBackground( backgroundInapplicalibleColorLight );
                        label.setBackground( java.awt.Color.WHITE );
                    }
                    else
                    {
                        label.setBackground( backgroundInapplicalibleColor );
                    }
                }
            }
            else
            {
                    label.setBackground( backgroundInapplicalibleColorLight );                    
                    // label.setForeground( java.awt.Color.BLACK );
            }
        }
        else
        {
            label.setText( csd.getTableCellText() );
            label.setHorizontalAlignment( tableCellHorizontalAlignment );
            if( isSelected )
            {
                label.setOpaque( true );
                if( hasFocus )
                {
                    // logger.debug( row + " / " + col + " isSelected and hasfocus" );
                    // label.setBackground( java.awt.Color.WHITE );
                    label.setBackground( java.awt.Color.LIGHT_GRAY );
                    label.setForeground( java.awt.Color.BLACK );
                }
                else
                {
                    // logger.debug( row + " / " + col + " isSelected" );
                    if( lastSelectedCol == col && lastSelectedRow == row )
                    {
                        label.setBackground( java.awt.Color.WHITE );
                        label.setForeground( java.awt.Color.BLACK );
                    }
                    else
                    {
                        label.setBackground( java.awt.Color.lightGray);
                        label.setForeground( java.awt.Color.BLACK );
                    }
                }
            }
            else
            {
                // label.setOpaque( true );
                // label.setBackground( java.awt.Color.GREEN );
                label.setForeground( java.awt.Color.BLUE );
            }
        }        
        return label;
    }    
}
