package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="AscomycetesHierarchy"
 *     
*/
public class AscomycetesHierarchy implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3617860763415623734L;

    /** identifier field */
    private Integer id;

    /** nullable persistent field */
    private String feld1;

    /** nullable persistent field */
    private String name;

    /** nullable persistent field */
    private String author;

    /** nullable persistent field */
    private Integer parentId;

    /** nullable persistent field */
    private String parentName;

    /** nullable persistent field */
    private String genusOrSupragenericName;

    /** nullable persistent field */
    private String taxonomicRank;

    /** nullable persistent field */
    private String basionymAutors;

    /** nullable persistent field */
    private Integer hierarchyPositionUncertain;

    /** nullable persistent field */
    private Integer nameId;

    /** nullable persistent field */
    private Integer nameParentId;

    /** nullable persistent field */
    private Boolean ignore;

    /** full constructor */
    public AscomycetesHierarchy(Integer id, String feld1, String name, String author, Integer parentId, String parentName, String genusOrSupragenericName, String taxonomicRank, String basionymAutors, Integer hierarchyPositionUncertain, Integer nameId, Integer nameParentId, Boolean ignore) {
        this.id = id;
        this.feld1 = feld1;
        this.name = name;
        this.author = author;
        this.parentId = parentId;
        this.parentName = parentName;
        this.genusOrSupragenericName = genusOrSupragenericName;
        this.taxonomicRank = taxonomicRank;
        this.basionymAutors = basionymAutors;
        this.hierarchyPositionUncertain = hierarchyPositionUncertain;
        this.nameId = nameId;
        this.nameParentId = nameParentId;
        this.ignore = ignore;
    }

    /** default constructor */
    public AscomycetesHierarchy() {
    }

    /** minimal constructor */
    public AscomycetesHierarchy(Integer id) {
        this.id = id;
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *             type="java.lang.Integer"
     *             column="ID"
     *         
     */
    public Integer getId() {
        return this.id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    /** 
     *            @hibernate.property
     *             column="Feld1"
     *             length="255"
     *         
     */
    public String getFeld1() {
        return this.feld1;
    }

    public void setFeld1(String feld1) {
        this.feld1 = feld1;
    }

    /** 
     *            @hibernate.property
     *             column="Name"
     *             length="100"
     *         
     */
    public String getName() {
        return this.name;
    }

    public void setName(String name) {
        this.name = name;
    }

    /** 
     *            @hibernate.property
     *             column="Author"
     *             length="100"
     *         
     */
    public String getAuthor() {
        return this.author;
    }

    public void setAuthor(String author) {
        this.author = author;
    }

    /** 
     *            @hibernate.property
     *             column="ParentID"
     *             length="10"
     *         
     */
    public Integer getParentId() {
        return this.parentId;
    }

    public void setParentId(Integer parentId) {
        this.parentId = parentId;
    }

    /** 
     *            @hibernate.property
     *             column="ParentName"
     *             length="50"
     *         
     */
    public String getParentName() {
        return this.parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }

    /** 
     *            @hibernate.property
     *             column="GenusOrSupragenericName"
     *             length="255"
     *         
     */
    public String getGenusOrSupragenericName() {
        return this.genusOrSupragenericName;
    }

    public void setGenusOrSupragenericName(String genusOrSupragenericName) {
        this.genusOrSupragenericName = genusOrSupragenericName;
    }

    /** 
     *            @hibernate.property
     *             column="TaxonomicRank"
     *             length="50"
     *         
     */
    public String getTaxonomicRank() {
        return this.taxonomicRank;
    }

    public void setTaxonomicRank(String taxonomicRank) {
        this.taxonomicRank = taxonomicRank;
    }

    /** 
     *            @hibernate.property
     *             column="BasionymAutors"
     *             length="255"
     *         
     */
    public String getBasionymAutors() {
        return this.basionymAutors;
    }

    public void setBasionymAutors(String basionymAutors) {
        this.basionymAutors = basionymAutors;
    }

    /** 
     *            @hibernate.property
     *             column="HierarchyPositionUncertain"
     *             length="10"
     *         
     */
    public Integer getHierarchyPositionUncertain() {
        return this.hierarchyPositionUncertain;
    }

    public void setHierarchyPositionUncertain(Integer hierarchyPositionUncertain) {
        this.hierarchyPositionUncertain = hierarchyPositionUncertain;
    }

    /** 
     *            @hibernate.property
     *             column="NameID"
     *             length="10"
     *         
     */
    public Integer getNameId() {
        return this.nameId;
    }

    public void setNameId(Integer nameId) {
        this.nameId = nameId;
    }

    /** 
     *            @hibernate.property
     *             column="NameParentID"
     *             length="10"
     *         
     */
    public Integer getNameParentId() {
        return this.nameParentId;
    }

    public void setNameParentId(Integer nameParentId) {
        this.nameParentId = nameParentId;
    }

    /** 
     *            @hibernate.property
     *             column="Ignore"
     *             length="1"
     *         
     */
    public Boolean getIgnore() {
        return this.ignore;
    }

    public void setIgnore(Boolean ignore) {
        this.ignore = ignore;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("id", getId())
            .toString();
    }

}
