package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import java.util.Date;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="TaxonHierarchy_Log"
 *     
*/
public class TaxonHierarchyLog implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3834306233036517431L;

    /** identifier field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonHierarchyLogPK comp_id;

    /** nullable persistent field */
    private Integer nameParentId;

    /** nullable persistent field */
    private String hierarchyRefId;

    /** nullable persistent field */
    private String hierarchyRefText;

    /** nullable persistent field */
    private String hierarchyRefDetail;

    /** nullable persistent field */
    private Boolean hierarchyPositionIsUncertain;

    /** nullable persistent field */
    private String hierarchyTypistsNotes;

    /** nullable persistent field */
    private String hierarchyListCache;

    /** nullable persistent field */
    private String logInsertedBy;

    /** nullable persistent field */
    private Date logInsertedWhen;

    /** nullable persistent field */
    private String logUpdatedBy;

    /** nullable persistent field */
    private Date logUpdatedWhen;

    /** nullable persistent field */
    private String logState;

    /** nullable persistent field */
    private String logUser;

    /** full constructor */
    public TaxonHierarchyLog(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonHierarchyLogPK comp_id, Integer nameParentId, String hierarchyRefId, String hierarchyRefText, String hierarchyRefDetail, Boolean hierarchyPositionIsUncertain, String hierarchyTypistsNotes, String hierarchyListCache, String logInsertedBy, Date logInsertedWhen, String logUpdatedBy, Date logUpdatedWhen, String logState, String logUser) {
        this.comp_id = comp_id;
        this.nameParentId = nameParentId;
        this.hierarchyRefId = hierarchyRefId;
        this.hierarchyRefText = hierarchyRefText;
        this.hierarchyRefDetail = hierarchyRefDetail;
        this.hierarchyPositionIsUncertain = hierarchyPositionIsUncertain;
        this.hierarchyTypistsNotes = hierarchyTypistsNotes;
        this.hierarchyListCache = hierarchyListCache;
        this.logInsertedBy = logInsertedBy;
        this.logInsertedWhen = logInsertedWhen;
        this.logUpdatedBy = logUpdatedBy;
        this.logUpdatedWhen = logUpdatedWhen;
        this.logState = logState;
        this.logUser = logUser;
    }

    /** default constructor */
    public TaxonHierarchyLog() {
    }

    /** minimal constructor */
    public TaxonHierarchyLog(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonHierarchyLogPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonHierarchyLogPK getComp_id() {
        return this.comp_id;
    }

    public void setComp_id(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonHierarchyLogPK comp_id) {
        this.comp_id = comp_id;
    }

    /** 
     *            @hibernate.property
     *             column="NameParentID"
     *             length="10"
     *         
     */
    public Integer getNameParentId() {
        return this.nameParentId;
    }

    public void setNameParentId(Integer nameParentId) {
        this.nameParentId = nameParentId;
    }

    /** 
     *            @hibernate.property
     *             column="HierarchyRefID"
     *             length="20"
     *         
     */
    public String getHierarchyRefId() {
        return this.hierarchyRefId;
    }

    public void setHierarchyRefId(String hierarchyRefId) {
        this.hierarchyRefId = hierarchyRefId;
    }

    /** 
     *            @hibernate.property
     *             column="HierarchyRefText"
     *             length="255"
     *         
     */
    public String getHierarchyRefText() {
        return this.hierarchyRefText;
    }

    public void setHierarchyRefText(String hierarchyRefText) {
        this.hierarchyRefText = hierarchyRefText;
    }

    /** 
     *            @hibernate.property
     *             column="HierarchyRefDetail"
     *             length="255"
     *         
     */
    public String getHierarchyRefDetail() {
        return this.hierarchyRefDetail;
    }

    public void setHierarchyRefDetail(String hierarchyRefDetail) {
        this.hierarchyRefDetail = hierarchyRefDetail;
    }

    /** 
     *            @hibernate.property
     *             column="HierarchyPositionIsUncertain"
     *             length="1"
     *         
     */
    public Boolean getHierarchyPositionIsUncertain() {
        return this.hierarchyPositionIsUncertain;
    }

    public void setHierarchyPositionIsUncertain(Boolean hierarchyPositionIsUncertain) {
        this.hierarchyPositionIsUncertain = hierarchyPositionIsUncertain;
    }

    /** 
     *            @hibernate.property
     *             column="HierarchyTypistsNotes"
     *             length="255"
     *         
     */
    public String getHierarchyTypistsNotes() {
        return this.hierarchyTypistsNotes;
    }

    public void setHierarchyTypistsNotes(String hierarchyTypistsNotes) {
        this.hierarchyTypistsNotes = hierarchyTypistsNotes;
    }

    /** 
     *            @hibernate.property
     *             column="HierarchyListCache"
     *             length="1000"
     *         
     */
    public String getHierarchyListCache() {
        return this.hierarchyListCache;
    }

    public void setHierarchyListCache(String hierarchyListCache) {
        this.hierarchyListCache = hierarchyListCache;
    }

    /** 
     *            @hibernate.property
     *             column="LogInsertedBy"
     *             length="50"
     *         
     */
    public String getLogInsertedBy() {
        return this.logInsertedBy;
    }

    public void setLogInsertedBy(String logInsertedBy) {
        this.logInsertedBy = logInsertedBy;
    }

    /** 
     *            @hibernate.property
     *             column="LogInsertedWhen"
     *             length="16"
     *         
     */
    public Date getLogInsertedWhen() {
        return this.logInsertedWhen;
    }

    public void setLogInsertedWhen(Date logInsertedWhen) {
        this.logInsertedWhen = logInsertedWhen;
    }

    /** 
     *            @hibernate.property
     *             column="LogUpdatedBy"
     *             length="50"
     *         
     */
    public String getLogUpdatedBy() {
        return this.logUpdatedBy;
    }

    public void setLogUpdatedBy(String logUpdatedBy) {
        this.logUpdatedBy = logUpdatedBy;
    }

    /** 
     *            @hibernate.property
     *             column="LogUpdatedWhen"
     *             length="16"
     *         
     */
    public Date getLogUpdatedWhen() {
        return this.logUpdatedWhen;
    }

    public void setLogUpdatedWhen(Date logUpdatedWhen) {
        this.logUpdatedWhen = logUpdatedWhen;
    }

    /** 
     *            @hibernate.property
     *             column="LogState"
     *             length="1"
     *         
     */
    public String getLogState() {
        return this.logState;
    }

    public void setLogState(String logState) {
        this.logState = logState;
    }

    /** 
     *            @hibernate.property
     *             column="LogUser"
     *             length="50"
     *         
     */
    public String getLogUser() {
        return this.logUser;
    }

    public void setLogUser(String logUser) {
        this.logUser = logUser;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("comp_id", getComp_id())
            .toString();
    }

    public boolean equals(Object other) {
        if ( (this == other ) ) return true;
        if ( !(other instanceof TaxonHierarchyLog) ) return false;
        TaxonHierarchyLog castOther = (TaxonHierarchyLog) other;
        return new EqualsBuilder()
            .append(this.getComp_id(), castOther.getComp_id())
            .isEquals();
    }

    public int hashCode() {
        return new HashCodeBuilder()
            .append(getComp_id())
            .toHashCode();
    }

}
