package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import java.util.Date;
import java.util.Set;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="TaxonName"
 *     
*/
public class TaxonName implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3258125843279524408L;

    /** identifier field */
    private Integer nameId;

    /** nullable persistent field */
    private String taxonNameCache;

    /** nullable persistent field */
    private String genusOrSupragenericName;

    /** nullable persistent field */
    private String infragenericEpithet;

    /** nullable persistent field */
    private String speciesEpithet;

    /** nullable persistent field */
    private String infraspecificEpithet;

    /** nullable persistent field */
    private String basionymAuthors;

    /** nullable persistent field */
    private String combiningAuthors;

    /** nullable persistent field */
    private String publishingAuthors;

    /** nullable persistent field */
    private String sanctioningAuthor;

    /** nullable persistent field */
    private String nonNomenclaturalNameSuffix;

    /** nullable persistent field */
    private Boolean isHybrid;

    /** nullable persistent field */
    private String referenceTitle;

    /** nullable persistent field */
    private Integer referenceId;

    /** nullable persistent field */
    private String volume;

    /** nullable persistent field */
    private String issue;

    /** nullable persistent field */
    private String page;

    /** nullable persistent field */
    private Short yearOfPubl;

    /** nullable persistent field */
    private Short yearOnPubl;

    /** nullable persistent field */
    private String indexingReference;

    /** nullable persistent field */
    private String originalOrthography;

    /** nullable persistent field */
    private String nomenclaturalStatus;

    /** nullable persistent field */
    private String nomenclaturalComment;

    /** nullable persistent field */
    private String typification;

    /** nullable persistent field */
    private String typificationDetails;

    /** nullable persistent field */
    private String typeSpecimenSubstrate;

    /** nullable persistent field */
    private String typeSpecimenLocality;

    /** nullable persistent field */
    private String typificationReferenceTitle;

    /** nullable persistent field */
    private Integer typificationReferenceId;

    /** nullable persistent field */
    private String typificationNotes;

    /** nullable persistent field */
    private String anamorphTeleomorph;

    /** nullable persistent field */
    private String typistNotes;

    /** nullable persistent field */
    private Boolean ignoreButKeepForReference;

    /** nullable persistent field */
    private String logInsertedBy;

    /** nullable persistent field */
    private Date logInsertedWhen;

    /** nullable persistent field */
    private String logUpdatedBy;

    /** nullable persistent field */
    private Date logUpdatedWhen;

    /** nullable persistent field */
    private Short ok;

    /** nullable persistent field */
    private Integer fungiNameId;

    /** persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalCodeEnum taxonNameNomenclaturalCodeEnum;

    /** persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalStatusEnum taxonNameNomenclaturalStatusEnum;

    /** persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameCreationTypeEnum taxonNameCreationTypeEnum;

    /** persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameTaxonomicRankEnum taxonNameTaxonomicRankEnum;

    /** persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId4;

    /** persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId3;

    /** persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByBasedOnNameId;

    /** persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameBySpeciesGenusNameId;

    /** persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId2;

    /** persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId1;

    /** persistent field */
    private Set taxonNamesByHybridNameId4;

    /** persistent field */
    private Set taxonNamesByHybridNameId3;

    /** persistent field */
    private Set taxonNamesByBasedOnNameId;

    /** persistent field */
    private Set taxonNamesBySpeciesGenusNameId;

    /** persistent field */
    private Set taxonNamesByHybridNameId2;

    /** persistent field */
    private Set taxonNamesByHybridNameId1;

    /** persistent field */
    private Set taxonNameExternalIds;

    /** persistent field */
    private Set taxonHierarchies;

    /** persistent field */
    private Set taxonAcceptedNames;

    /** persistent field */
    private Set taxonSynonymiesByNameId;

    /** persistent field */
    private Set taxonSynonymiesBySynNameId;

    /** full constructor */
    public TaxonName(Integer nameId, String taxonNameCache, String genusOrSupragenericName, String infragenericEpithet, String speciesEpithet, String infraspecificEpithet, String basionymAuthors, String combiningAuthors, String publishingAuthors, String sanctioningAuthor, String nonNomenclaturalNameSuffix, Boolean isHybrid, String referenceTitle, Integer referenceId, String volume, String issue, String page, Short yearOfPubl, Short yearOnPubl, String indexingReference, String originalOrthography, String nomenclaturalStatus, String nomenclaturalComment, String typification, String typificationDetails, String typeSpecimenSubstrate, String typeSpecimenLocality, String typificationReferenceTitle, Integer typificationReferenceId, String typificationNotes, String anamorphTeleomorph, String typistNotes, Boolean ignoreButKeepForReference, String logInsertedBy, Date logInsertedWhen, String logUpdatedBy, Date logUpdatedWhen, Short ok, Integer fungiNameId, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalCodeEnum taxonNameNomenclaturalCodeEnum, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalStatusEnum taxonNameNomenclaturalStatusEnum, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameCreationTypeEnum taxonNameCreationTypeEnum, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameTaxonomicRankEnum taxonNameTaxonomicRankEnum, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId4, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId3, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByBasedOnNameId, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameBySpeciesGenusNameId, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId2, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId1, Set taxonNamesByHybridNameId4, Set taxonNamesByHybridNameId3, Set taxonNamesByBasedOnNameId, Set taxonNamesBySpeciesGenusNameId, Set taxonNamesByHybridNameId2, Set taxonNamesByHybridNameId1, Set taxonNameExternalIds, Set taxonHierarchies, Set taxonAcceptedNames, Set taxonSynonymiesByNameId, Set taxonSynonymiesBySynNameId) {
        this.nameId = nameId;
        this.taxonNameCache = taxonNameCache;
        this.genusOrSupragenericName = genusOrSupragenericName;
        this.infragenericEpithet = infragenericEpithet;
        this.speciesEpithet = speciesEpithet;
        this.infraspecificEpithet = infraspecificEpithet;
        this.basionymAuthors = basionymAuthors;
        this.combiningAuthors = combiningAuthors;
        this.publishingAuthors = publishingAuthors;
        this.sanctioningAuthor = sanctioningAuthor;
        this.nonNomenclaturalNameSuffix = nonNomenclaturalNameSuffix;
        this.isHybrid = isHybrid;
        this.referenceTitle = referenceTitle;
        this.referenceId = referenceId;
        this.volume = volume;
        this.issue = issue;
        this.page = page;
        this.yearOfPubl = yearOfPubl;
        this.yearOnPubl = yearOnPubl;
        this.indexingReference = indexingReference;
        this.originalOrthography = originalOrthography;
        this.nomenclaturalStatus = nomenclaturalStatus;
        this.nomenclaturalComment = nomenclaturalComment;
        this.typification = typification;
        this.typificationDetails = typificationDetails;
        this.typeSpecimenSubstrate = typeSpecimenSubstrate;
        this.typeSpecimenLocality = typeSpecimenLocality;
        this.typificationReferenceTitle = typificationReferenceTitle;
        this.typificationReferenceId = typificationReferenceId;
        this.typificationNotes = typificationNotes;
        this.anamorphTeleomorph = anamorphTeleomorph;
        this.typistNotes = typistNotes;
        this.ignoreButKeepForReference = ignoreButKeepForReference;
        this.logInsertedBy = logInsertedBy;
        this.logInsertedWhen = logInsertedWhen;
        this.logUpdatedBy = logUpdatedBy;
        this.logUpdatedWhen = logUpdatedWhen;
        this.ok = ok;
        this.fungiNameId = fungiNameId;
        this.taxonNameNomenclaturalCodeEnum = taxonNameNomenclaturalCodeEnum;
        this.taxonNameNomenclaturalStatusEnum = taxonNameNomenclaturalStatusEnum;
        this.taxonNameCreationTypeEnum = taxonNameCreationTypeEnum;
        this.taxonNameTaxonomicRankEnum = taxonNameTaxonomicRankEnum;
        this.taxonNameByHybridNameId4 = taxonNameByHybridNameId4;
        this.taxonNameByHybridNameId3 = taxonNameByHybridNameId3;
        this.taxonNameByBasedOnNameId = taxonNameByBasedOnNameId;
        this.taxonNameBySpeciesGenusNameId = taxonNameBySpeciesGenusNameId;
        this.taxonNameByHybridNameId2 = taxonNameByHybridNameId2;
        this.taxonNameByHybridNameId1 = taxonNameByHybridNameId1;
        this.taxonNamesByHybridNameId4 = taxonNamesByHybridNameId4;
        this.taxonNamesByHybridNameId3 = taxonNamesByHybridNameId3;
        this.taxonNamesByBasedOnNameId = taxonNamesByBasedOnNameId;
        this.taxonNamesBySpeciesGenusNameId = taxonNamesBySpeciesGenusNameId;
        this.taxonNamesByHybridNameId2 = taxonNamesByHybridNameId2;
        this.taxonNamesByHybridNameId1 = taxonNamesByHybridNameId1;
        this.taxonNameExternalIds = taxonNameExternalIds;
        this.taxonHierarchies = taxonHierarchies;
        this.taxonAcceptedNames = taxonAcceptedNames;
        this.taxonSynonymiesByNameId = taxonSynonymiesByNameId;
        this.taxonSynonymiesBySynNameId = taxonSynonymiesBySynNameId;
    }

    /** default constructor */
    public TaxonName() {
    }

    /** minimal constructor */
    public TaxonName(Integer nameId, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalCodeEnum taxonNameNomenclaturalCodeEnum, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalStatusEnum taxonNameNomenclaturalStatusEnum, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameCreationTypeEnum taxonNameCreationTypeEnum, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameTaxonomicRankEnum taxonNameTaxonomicRankEnum, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId4, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId3, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByBasedOnNameId, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameBySpeciesGenusNameId, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId2, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId1, Set taxonNamesByHybridNameId4, Set taxonNamesByHybridNameId3, Set taxonNamesByBasedOnNameId, Set taxonNamesBySpeciesGenusNameId, Set taxonNamesByHybridNameId2, Set taxonNamesByHybridNameId1, Set taxonNameExternalIds, Set taxonHierarchies, Set taxonAcceptedNames, Set taxonSynonymiesByNameId, Set taxonSynonymiesBySynNameId) {
        this.nameId = nameId;
        this.taxonNameNomenclaturalCodeEnum = taxonNameNomenclaturalCodeEnum;
        this.taxonNameNomenclaturalStatusEnum = taxonNameNomenclaturalStatusEnum;
        this.taxonNameCreationTypeEnum = taxonNameCreationTypeEnum;
        this.taxonNameTaxonomicRankEnum = taxonNameTaxonomicRankEnum;
        this.taxonNameByHybridNameId4 = taxonNameByHybridNameId4;
        this.taxonNameByHybridNameId3 = taxonNameByHybridNameId3;
        this.taxonNameByBasedOnNameId = taxonNameByBasedOnNameId;
        this.taxonNameBySpeciesGenusNameId = taxonNameBySpeciesGenusNameId;
        this.taxonNameByHybridNameId2 = taxonNameByHybridNameId2;
        this.taxonNameByHybridNameId1 = taxonNameByHybridNameId1;
        this.taxonNamesByHybridNameId4 = taxonNamesByHybridNameId4;
        this.taxonNamesByHybridNameId3 = taxonNamesByHybridNameId3;
        this.taxonNamesByBasedOnNameId = taxonNamesByBasedOnNameId;
        this.taxonNamesBySpeciesGenusNameId = taxonNamesBySpeciesGenusNameId;
        this.taxonNamesByHybridNameId2 = taxonNamesByHybridNameId2;
        this.taxonNamesByHybridNameId1 = taxonNamesByHybridNameId1;
        this.taxonNameExternalIds = taxonNameExternalIds;
        this.taxonHierarchies = taxonHierarchies;
        this.taxonAcceptedNames = taxonAcceptedNames;
        this.taxonSynonymiesByNameId = taxonSynonymiesByNameId;
        this.taxonSynonymiesBySynNameId = taxonSynonymiesBySynNameId;
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *             type="java.lang.Integer"
     *             column="NameID"
     *         
     */
    public Integer getNameId() {
        return this.nameId;
    }

    public void setNameId(Integer nameId) {
        this.nameId = nameId;
    }

    /** 
     *            @hibernate.property
     *             column="TaxonNameCache"
     *             length="255"
     *         
     */
    public String getTaxonNameCache() {
        return this.taxonNameCache;
    }

    public void setTaxonNameCache(String taxonNameCache) {
        this.taxonNameCache = taxonNameCache;
    }

    /** 
     *            @hibernate.property
     *             column="GenusOrSupragenericName"
     *             length="200"
     *         
     */
    public String getGenusOrSupragenericName() {
        return this.genusOrSupragenericName;
    }

    public void setGenusOrSupragenericName(String genusOrSupragenericName) {
        this.genusOrSupragenericName = genusOrSupragenericName;
    }

    /** 
     *            @hibernate.property
     *             column="InfragenericEpithet"
     *             length="200"
     *         
     */
    public String getInfragenericEpithet() {
        return this.infragenericEpithet;
    }

    public void setInfragenericEpithet(String infragenericEpithet) {
        this.infragenericEpithet = infragenericEpithet;
    }

    /** 
     *            @hibernate.property
     *             column="SpeciesEpithet"
     *             length="255"
     *         
     */
    public String getSpeciesEpithet() {
        return this.speciesEpithet;
    }

    public void setSpeciesEpithet(String speciesEpithet) {
        this.speciesEpithet = speciesEpithet;
    }

    /** 
     *            @hibernate.property
     *             column="InfraspecificEpithet"
     *             length="255"
     *         
     */
    public String getInfraspecificEpithet() {
        return this.infraspecificEpithet;
    }

    public void setInfraspecificEpithet(String infraspecificEpithet) {
        this.infraspecificEpithet = infraspecificEpithet;
    }

    /** 
     *            @hibernate.property
     *             column="BasionymAuthors"
     *             length="255"
     *         
     */
    public String getBasionymAuthors() {
        return this.basionymAuthors;
    }

    public void setBasionymAuthors(String basionymAuthors) {
        this.basionymAuthors = basionymAuthors;
    }

    /** 
     *            @hibernate.property
     *             column="CombiningAuthors"
     *             length="255"
     *         
     */
    public String getCombiningAuthors() {
        return this.combiningAuthors;
    }

    public void setCombiningAuthors(String combiningAuthors) {
        this.combiningAuthors = combiningAuthors;
    }

    /** 
     *            @hibernate.property
     *             column="PublishingAuthors"
     *             length="255"
     *         
     */
    public String getPublishingAuthors() {
        return this.publishingAuthors;
    }

    public void setPublishingAuthors(String publishingAuthors) {
        this.publishingAuthors = publishingAuthors;
    }

    /** 
     *            @hibernate.property
     *             column="SanctioningAuthor"
     *             length="255"
     *         
     */
    public String getSanctioningAuthor() {
        return this.sanctioningAuthor;
    }

    public void setSanctioningAuthor(String sanctioningAuthor) {
        this.sanctioningAuthor = sanctioningAuthor;
    }

    /** 
     *            @hibernate.property
     *             column="NonNomenclaturalNameSuffix"
     *             length="200"
     *         
     */
    public String getNonNomenclaturalNameSuffix() {
        return this.nonNomenclaturalNameSuffix;
    }

    public void setNonNomenclaturalNameSuffix(String nonNomenclaturalNameSuffix) {
        this.nonNomenclaturalNameSuffix = nonNomenclaturalNameSuffix;
    }

    /** 
     *            @hibernate.property
     *             column="IsHybrid"
     *             length="1"
     *         
     */
    public Boolean getIsHybrid() {
        return this.isHybrid;
    }

    public void setIsHybrid(Boolean isHybrid) {
        this.isHybrid = isHybrid;
    }

    /** 
     *            @hibernate.property
     *             column="ReferenceTitle"
     *             length="255"
     *         
     */
    public String getReferenceTitle() {
        return this.referenceTitle;
    }

    public void setReferenceTitle(String referenceTitle) {
        this.referenceTitle = referenceTitle;
    }

    /** 
     *            @hibernate.property
     *             column="ReferenceID"
     *             length="10"
     *         
     */
    public Integer getReferenceId() {
        return this.referenceId;
    }

    public void setReferenceId(Integer referenceId) {
        this.referenceId = referenceId;
    }

    /** 
     *            @hibernate.property
     *             column="Volume"
     *             length="20"
     *         
     */
    public String getVolume() {
        return this.volume;
    }

    public void setVolume(String volume) {
        this.volume = volume;
    }

    /** 
     *            @hibernate.property
     *             column="Issue"
     *             length="255"
     *         
     */
    public String getIssue() {
        return this.issue;
    }

    public void setIssue(String issue) {
        this.issue = issue;
    }

    /** 
     *            @hibernate.property
     *             column="Page"
     *             length="10"
     *         
     */
    public String getPage() {
        return this.page;
    }

    public void setPage(String page) {
        this.page = page;
    }

    /** 
     *            @hibernate.property
     *             column="YearOfPubl"
     *             length="5"
     *         
     */
    public Short getYearOfPubl() {
        return this.yearOfPubl;
    }

    public void setYearOfPubl(Short yearOfPubl) {
        this.yearOfPubl = yearOfPubl;
    }

    /** 
     *            @hibernate.property
     *             column="YearOnPubl"
     *             length="5"
     *         
     */
    public Short getYearOnPubl() {
        return this.yearOnPubl;
    }

    public void setYearOnPubl(Short yearOnPubl) {
        this.yearOnPubl = yearOnPubl;
    }

    /** 
     *            @hibernate.property
     *             column="IndexingReference"
     *             length="255"
     *         
     */
    public String getIndexingReference() {
        return this.indexingReference;
    }

    public void setIndexingReference(String indexingReference) {
        this.indexingReference = indexingReference;
    }

    /** 
     *            @hibernate.property
     *             column="OriginalOrthography"
     *             length="255"
     *         
     */
    public String getOriginalOrthography() {
        return this.originalOrthography;
    }

    public void setOriginalOrthography(String originalOrthography) {
        this.originalOrthography = originalOrthography;
    }

    /** 
     *            @hibernate.property
     *             column="NomenclaturalStatus"
     *             length="50"
     *         
     */
    public String getNomenclaturalStatus() {
        return this.nomenclaturalStatus;
    }

    public void setNomenclaturalStatus(String nomenclaturalStatus) {
        this.nomenclaturalStatus = nomenclaturalStatus;
    }

    /** 
     *            @hibernate.property
     *             column="NomenclaturalComment"
     *             length="500"
     *         
     */
    public String getNomenclaturalComment() {
        return this.nomenclaturalComment;
    }

    public void setNomenclaturalComment(String nomenclaturalComment) {
        this.nomenclaturalComment = nomenclaturalComment;
    }

    /** 
     *            @hibernate.property
     *             column="Typification"
     *             length="50"
     *         
     */
    public String getTypification() {
        return this.typification;
    }

    public void setTypification(String typification) {
        this.typification = typification;
    }

    /** 
     *            @hibernate.property
     *             column="TypificationDetails"
     *             length="255"
     *         
     */
    public String getTypificationDetails() {
        return this.typificationDetails;
    }

    public void setTypificationDetails(String typificationDetails) {
        this.typificationDetails = typificationDetails;
    }

    /** 
     *            @hibernate.property
     *             column="TypeSpecimenSubstrate"
     *             length="255"
     *         
     */
    public String getTypeSpecimenSubstrate() {
        return this.typeSpecimenSubstrate;
    }

    public void setTypeSpecimenSubstrate(String typeSpecimenSubstrate) {
        this.typeSpecimenSubstrate = typeSpecimenSubstrate;
    }

    /** 
     *            @hibernate.property
     *             column="TypeSpecimenLocality"
     *             length="255"
     *         
     */
    public String getTypeSpecimenLocality() {
        return this.typeSpecimenLocality;
    }

    public void setTypeSpecimenLocality(String typeSpecimenLocality) {
        this.typeSpecimenLocality = typeSpecimenLocality;
    }

    /** 
     *            @hibernate.property
     *             column="TypificationReferenceTitle"
     *             length="100"
     *         
     */
    public String getTypificationReferenceTitle() {
        return this.typificationReferenceTitle;
    }

    public void setTypificationReferenceTitle(String typificationReferenceTitle) {
        this.typificationReferenceTitle = typificationReferenceTitle;
    }

    /** 
     *            @hibernate.property
     *             column="TypificationReferenceID"
     *             length="10"
     *         
     */
    public Integer getTypificationReferenceId() {
        return this.typificationReferenceId;
    }

    public void setTypificationReferenceId(Integer typificationReferenceId) {
        this.typificationReferenceId = typificationReferenceId;
    }

    /** 
     *            @hibernate.property
     *             column="TypificationNotes"
     *             length="200"
     *         
     */
    public String getTypificationNotes() {
        return this.typificationNotes;
    }

    public void setTypificationNotes(String typificationNotes) {
        this.typificationNotes = typificationNotes;
    }

    /** 
     *            @hibernate.property
     *             column="AnamorphTeleomorph"
     *             length="255"
     *         
     */
    public String getAnamorphTeleomorph() {
        return this.anamorphTeleomorph;
    }

    public void setAnamorphTeleomorph(String anamorphTeleomorph) {
        this.anamorphTeleomorph = anamorphTeleomorph;
    }

    /** 
     *            @hibernate.property
     *             column="TypistNotes"
     *             length="200"
     *         
     */
    public String getTypistNotes() {
        return this.typistNotes;
    }

    public void setTypistNotes(String typistNotes) {
        this.typistNotes = typistNotes;
    }

    /** 
     *            @hibernate.property
     *             column="IgnoreButKeepForReference"
     *             length="1"
     *         
     */
    public Boolean getIgnoreButKeepForReference() {
        return this.ignoreButKeepForReference;
    }

    public void setIgnoreButKeepForReference(Boolean ignoreButKeepForReference) {
        this.ignoreButKeepForReference = ignoreButKeepForReference;
    }

    /** 
     *            @hibernate.property
     *             column="LogInsertedBy"
     *             length="50"
     *         
     */
    public String getLogInsertedBy() {
        return this.logInsertedBy;
    }

    public void setLogInsertedBy(String logInsertedBy) {
        this.logInsertedBy = logInsertedBy;
    }

    /** 
     *            @hibernate.property
     *             column="LogInsertedWhen"
     *             length="16"
     *         
     */
    public Date getLogInsertedWhen() {
        return this.logInsertedWhen;
    }

    public void setLogInsertedWhen(Date logInsertedWhen) {
        this.logInsertedWhen = logInsertedWhen;
    }

    /** 
     *            @hibernate.property
     *             column="LogUpdatedBy"
     *             length="50"
     *         
     */
    public String getLogUpdatedBy() {
        return this.logUpdatedBy;
    }

    public void setLogUpdatedBy(String logUpdatedBy) {
        this.logUpdatedBy = logUpdatedBy;
    }

    /** 
     *            @hibernate.property
     *             column="LogUpdatedWhen"
     *             length="16"
     *         
     */
    public Date getLogUpdatedWhen() {
        return this.logUpdatedWhen;
    }

    public void setLogUpdatedWhen(Date logUpdatedWhen) {
        this.logUpdatedWhen = logUpdatedWhen;
    }

    /** 
     *            @hibernate.property
     *             column="OK"
     *             length="5"
     *         
     */
    public Short getOk() {
        return this.ok;
    }

    public void setOk(Short ok) {
        this.ok = ok;
    }

    /** 
     *            @hibernate.property
     *             column="FungiNameID"
     *             length="10"
     *         
     */
    public Integer getFungiNameId() {
        return this.fungiNameId;
    }

    public void setFungiNameId(Integer fungiNameId) {
        this.fungiNameId = fungiNameId;
    }

    /** 
     *            @hibernate.many-to-one
     *             not-null="true"
     *            @hibernate.column name="NomenclaturalCode"         
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalCodeEnum getTaxonNameNomenclaturalCodeEnum() {
        return this.taxonNameNomenclaturalCodeEnum;
    }

    public void setTaxonNameNomenclaturalCodeEnum(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalCodeEnum taxonNameNomenclaturalCodeEnum) {
        this.taxonNameNomenclaturalCodeEnum = taxonNameNomenclaturalCodeEnum;
    }

    /** 
     *            @hibernate.many-to-one
     *             not-null="true"
     *            @hibernate.column name="NomenclaturalCode"         
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalStatusEnum getTaxonNameNomenclaturalStatusEnum() {
        return this.taxonNameNomenclaturalStatusEnum;
    }

    public void setTaxonNameNomenclaturalStatusEnum(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameNomenclaturalStatusEnum taxonNameNomenclaturalStatusEnum) {
        this.taxonNameNomenclaturalStatusEnum = taxonNameNomenclaturalStatusEnum;
    }

    /** 
     *            @hibernate.many-to-one
     *             not-null="true"
     *            @hibernate.column name="CreationType"         
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameCreationTypeEnum getTaxonNameCreationTypeEnum() {
        return this.taxonNameCreationTypeEnum;
    }

    public void setTaxonNameCreationTypeEnum(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameCreationTypeEnum taxonNameCreationTypeEnum) {
        this.taxonNameCreationTypeEnum = taxonNameCreationTypeEnum;
    }

    /** 
     *            @hibernate.many-to-one
     *             not-null="true"
     *            @hibernate.column name="TaxonomicRank"         
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameTaxonomicRankEnum getTaxonNameTaxonomicRankEnum() {
        return this.taxonNameTaxonomicRankEnum;
    }

    public void setTaxonNameTaxonomicRankEnum(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameTaxonomicRankEnum taxonNameTaxonomicRankEnum) {
        this.taxonNameTaxonomicRankEnum = taxonNameTaxonomicRankEnum;
    }

    /** 
     *            @hibernate.many-to-one
     *             not-null="true"
     *            @hibernate.column name="HybridNameID4"         
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName getTaxonNameByHybridNameId4() {
        return this.taxonNameByHybridNameId4;
    }

    public void setTaxonNameByHybridNameId4(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId4) {
        this.taxonNameByHybridNameId4 = taxonNameByHybridNameId4;
    }

    /** 
     *            @hibernate.many-to-one
     *             not-null="true"
     *            @hibernate.column name="HybridNameID3"         
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName getTaxonNameByHybridNameId3() {
        return this.taxonNameByHybridNameId3;
    }

    public void setTaxonNameByHybridNameId3(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId3) {
        this.taxonNameByHybridNameId3 = taxonNameByHybridNameId3;
    }

    /** 
     *            @hibernate.many-to-one
     *             not-null="true"
     *            @hibernate.column name="BasedOnNameID"         
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName getTaxonNameByBasedOnNameId() {
        return this.taxonNameByBasedOnNameId;
    }

    public void setTaxonNameByBasedOnNameId(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByBasedOnNameId) {
        this.taxonNameByBasedOnNameId = taxonNameByBasedOnNameId;
    }

    /** 
     *            @hibernate.many-to-one
     *             not-null="true"
     *            @hibernate.column name="SpeciesGenusNameID"         
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName getTaxonNameBySpeciesGenusNameId() {
        return this.taxonNameBySpeciesGenusNameId;
    }

    public void setTaxonNameBySpeciesGenusNameId(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameBySpeciesGenusNameId) {
        this.taxonNameBySpeciesGenusNameId = taxonNameBySpeciesGenusNameId;
    }

    /** 
     *            @hibernate.many-to-one
     *             not-null="true"
     *            @hibernate.column name="HybridNameID2"         
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName getTaxonNameByHybridNameId2() {
        return this.taxonNameByHybridNameId2;
    }

    public void setTaxonNameByHybridNameId2(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId2) {
        this.taxonNameByHybridNameId2 = taxonNameByHybridNameId2;
    }

    /** 
     *            @hibernate.many-to-one
     *             not-null="true"
     *            @hibernate.column name="HybridNameID1"         
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName getTaxonNameByHybridNameId1() {
        return this.taxonNameByHybridNameId1;
    }

    public void setTaxonNameByHybridNameId1(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName taxonNameByHybridNameId1) {
        this.taxonNameByHybridNameId1 = taxonNameByHybridNameId1;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="HybridNameID4"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName"
     *         
     */
    public Set getTaxonNamesByHybridNameId4() {
        return this.taxonNamesByHybridNameId4;
    }

    public void setTaxonNamesByHybridNameId4(Set taxonNamesByHybridNameId4) {
        this.taxonNamesByHybridNameId4 = taxonNamesByHybridNameId4;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="HybridNameID3"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName"
     *         
     */
    public Set getTaxonNamesByHybridNameId3() {
        return this.taxonNamesByHybridNameId3;
    }

    public void setTaxonNamesByHybridNameId3(Set taxonNamesByHybridNameId3) {
        this.taxonNamesByHybridNameId3 = taxonNamesByHybridNameId3;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="BasedOnNameID"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName"
     *         
     */
    public Set getTaxonNamesByBasedOnNameId() {
        return this.taxonNamesByBasedOnNameId;
    }

    public void setTaxonNamesByBasedOnNameId(Set taxonNamesByBasedOnNameId) {
        this.taxonNamesByBasedOnNameId = taxonNamesByBasedOnNameId;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="SpeciesGenusNameID"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName"
     *         
     */
    public Set getTaxonNamesBySpeciesGenusNameId() {
        return this.taxonNamesBySpeciesGenusNameId;
    }

    public void setTaxonNamesBySpeciesGenusNameId(Set taxonNamesBySpeciesGenusNameId) {
        this.taxonNamesBySpeciesGenusNameId = taxonNamesBySpeciesGenusNameId;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="HybridNameID2"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName"
     *         
     */
    public Set getTaxonNamesByHybridNameId2() {
        return this.taxonNamesByHybridNameId2;
    }

    public void setTaxonNamesByHybridNameId2(Set taxonNamesByHybridNameId2) {
        this.taxonNamesByHybridNameId2 = taxonNamesByHybridNameId2;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="HybridNameID1"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonName"
     *         
     */
    public Set getTaxonNamesByHybridNameId1() {
        return this.taxonNamesByHybridNameId1;
    }

    public void setTaxonNamesByHybridNameId1(Set taxonNamesByHybridNameId1) {
        this.taxonNamesByHybridNameId1 = taxonNamesByHybridNameId1;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="NameID"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameExternalId"
     *         
     */
    public Set getTaxonNameExternalIds() {
        return this.taxonNameExternalIds;
    }

    public void setTaxonNameExternalIds(Set taxonNameExternalIds) {
        this.taxonNameExternalIds = taxonNameExternalIds;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="NameID"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonHierarchy"
     *         
     */
    public Set getTaxonHierarchies() {
        return this.taxonHierarchies;
    }

    public void setTaxonHierarchies(Set taxonHierarchies) {
        this.taxonHierarchies = taxonHierarchies;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="NameID"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonAcceptedName"
     *         
     */
    public Set getTaxonAcceptedNames() {
        return this.taxonAcceptedNames;
    }

    public void setTaxonAcceptedNames(Set taxonAcceptedNames) {
        this.taxonAcceptedNames = taxonAcceptedNames;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="NameID"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonSynonymy"
     *         
     */
    public Set getTaxonSynonymiesByNameId() {
        return this.taxonSynonymiesByNameId;
    }

    public void setTaxonSynonymiesByNameId(Set taxonSynonymiesByNameId) {
        this.taxonSynonymiesByNameId = taxonSynonymiesByNameId;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="SynNameID"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonSynonymy"
     *         
     */
    public Set getTaxonSynonymiesBySynNameId() {
        return this.taxonSynonymiesBySynNameId;
    }

    public void setTaxonSynonymiesBySynNameId(Set taxonSynonymiesBySynNameId) {
        this.taxonSynonymiesBySynNameId = taxonSynonymiesBySynNameId;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("nameId", getNameId())
            .toString();
    }

}
