package net.metadiversity.diversity.navigator.hibernate.bsm;

import java.io.Serializable;
import java.util.Set;
import org.apache.commons.lang.builder.ToStringBuilder;


/** 
 *        @hibernate.class
 *         table="TaxonNameSynonymisationType_Enum"
 *     
*/
public class TaxonNameSynonymisationTypeEnum implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257006553411170355L;

    /** identifier field */
    private String code;

    /** nullable persistent field */
    private String description;

    /** nullable persistent field */
    private String displayText;

    /** nullable persistent field */
    private Short displayOrder;

    /** nullable persistent field */
    private Boolean displayEnable;

    /** nullable persistent field */
    private String internalNotes;

    /** persistent field */
    private net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameSynonymisationTypeEnum taxonNameSynonymisationTypeEnum;

    /** persistent field */
    private Set taxonNameSynonymisationTypeEnums;

    /** persistent field */
    private Set taxonSynonymies;

    /** full constructor */
    public TaxonNameSynonymisationTypeEnum(String code, String description, String displayText, Short displayOrder, Boolean displayEnable, String internalNotes, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameSynonymisationTypeEnum taxonNameSynonymisationTypeEnum, Set taxonNameSynonymisationTypeEnums, Set taxonSynonymies) {
        this.code = code;
        this.description = description;
        this.displayText = displayText;
        this.displayOrder = displayOrder;
        this.displayEnable = displayEnable;
        this.internalNotes = internalNotes;
        this.taxonNameSynonymisationTypeEnum = taxonNameSynonymisationTypeEnum;
        this.taxonNameSynonymisationTypeEnums = taxonNameSynonymisationTypeEnums;
        this.taxonSynonymies = taxonSynonymies;
    }

    /** default constructor */
    public TaxonNameSynonymisationTypeEnum() {
    }

    /** minimal constructor */
    public TaxonNameSynonymisationTypeEnum(String code, net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameSynonymisationTypeEnum taxonNameSynonymisationTypeEnum, Set taxonNameSynonymisationTypeEnums, Set taxonSynonymies) {
        this.code = code;
        this.taxonNameSynonymisationTypeEnum = taxonNameSynonymisationTypeEnum;
        this.taxonNameSynonymisationTypeEnums = taxonNameSynonymisationTypeEnums;
        this.taxonSynonymies = taxonSynonymies;
    }

    /** 
     *            @hibernate.id
     *             generator-class="assigned"
     *             type="java.lang.String"
     *             column="Code"
     *         
     */
    public String getCode() {
        return this.code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    /** 
     *            @hibernate.property
     *             column="Description"
     *             length="500"
     *         
     */
    public String getDescription() {
        return this.description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    /** 
     *            @hibernate.property
     *             column="DisplayText"
     *             length="50"
     *         
     */
    public String getDisplayText() {
        return this.displayText;
    }

    public void setDisplayText(String displayText) {
        this.displayText = displayText;
    }

    /** 
     *            @hibernate.property
     *             column="DisplayOrder"
     *             length="5"
     *         
     */
    public Short getDisplayOrder() {
        return this.displayOrder;
    }

    public void setDisplayOrder(Short displayOrder) {
        this.displayOrder = displayOrder;
    }

    /** 
     *            @hibernate.property
     *             column="DisplayEnable"
     *             length="1"
     *         
     */
    public Boolean getDisplayEnable() {
        return this.displayEnable;
    }

    public void setDisplayEnable(Boolean displayEnable) {
        this.displayEnable = displayEnable;
    }

    /** 
     *            @hibernate.property
     *             column="InternalNotes"
     *             length="500"
     *         
     */
    public String getInternalNotes() {
        return this.internalNotes;
    }

    public void setInternalNotes(String internalNotes) {
        this.internalNotes = internalNotes;
    }

    /** 
     *            @hibernate.many-to-one
     *             not-null="true"
     *            @hibernate.column name="ParentCode"         
     *         
     */
    public net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameSynonymisationTypeEnum getTaxonNameSynonymisationTypeEnum() {
        return this.taxonNameSynonymisationTypeEnum;
    }

    public void setTaxonNameSynonymisationTypeEnum(net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameSynonymisationTypeEnum taxonNameSynonymisationTypeEnum) {
        this.taxonNameSynonymisationTypeEnum = taxonNameSynonymisationTypeEnum;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="ParentCode"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonNameSynonymisationTypeEnum"
     *         
     */
    public Set getTaxonNameSynonymisationTypeEnums() {
        return this.taxonNameSynonymisationTypeEnums;
    }

    public void setTaxonNameSynonymisationTypeEnums(Set taxonNameSynonymisationTypeEnums) {
        this.taxonNameSynonymisationTypeEnums = taxonNameSynonymisationTypeEnums;
    }

    /** 
     *            @hibernate.set
     *             lazy="true"
     *             inverse="true"
     *             cascade="none"
     *            @hibernate.collection-key
     *             column="SynType"
     *            @hibernate.collection-one-to-many
     *             class="net.metadiversity.diversity.navigator.hibernate.bsm.TaxonSynonymy"
     *         
     */
    public Set getTaxonSynonymies() {
        return this.taxonSynonymies;
    }

    public void setTaxonSynonymies(Set taxonSynonymies) {
        this.taxonSynonymies = taxonSynonymies;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("code", getCode())
            .toString();
    }

}
