/*
 * UbtCollectionProjectPlugin.java
 *
 * Created on 18. November 2003, 16:15
 */

package net.metadiversity.diversity.navigator.projectPlugin;

import org.apache.log4j.Logger;

import net.metadiversity.diversity.navigator.checklists.ChecklistFileFilter;
import net.metadiversity.diversity.navigator.checklists.ChecklistFileName;
import net.metadiversity.diversity.navigator.checklists.WriteUnicodeFile;

import net.metadiversity.diversity.navigator.checklists.dataimport.ImportDataFile;
import net.metadiversity.diversity.navigator.checklists.dataimport.XmlConfigurationImpl;

import net.metadiversity.diversity.navigator.gui.DnOptionPane;
//import net.metadiversity.diversity.navigator.gui.ProjectQueryPanel;
//import net.metadiversity.diversity.navigator.gui.*;
//import net.metadiversity.diversity.navigator.gui.CollectionTransectGisVisualisation;

// ???
//import net.metadiversity.diversity.navigator.connection.ConnectionsManager;
//import net.metadiversity.diversity.navigator.connection.ConnectionInfo;


import net.metadiversity.diversity.navigator.checklists.database.DBChecklist;
/**
 *
 * @author  Dieter Neubacher
 */
public class DiversityChecklistsProjectPlugin extends Plugin
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3904674972936254515L;

    static Logger logger = Logger.getLogger( DiversityChecklistsProjectPlugin.class.getName() );
    
    private DBChecklist db;     // checklists database
    
    /** Creates a new instance of UbtCollectionProjectPlugin */
    public DiversityChecklistsProjectPlugin()
    {        
        super( "Lias", "Diversity Workbench" );        // set ProjectName an dbgroup
        
      	db = new DBChecklist();

        addProjectDatabase( null, "LIAS Checklists" );
        addProjectDatabase( null, "LIAS Descriptive Data (disabled)" );
        
        
        
/*                
        ProjectQueryPanel qp = new ProjectQueryPanel( this, "Lias", "Diversity Workbench", "LIAS Checklists", "LIAS Descriptive Data (disabled)" );
        
        setFilterPanel( qp );
        // ???
        qp.setQueryResultComponent( getGridViewPanel() );
        
        QueryResultSetTable qrst = null;
        try
        {
            // get conection info for this database       
            ConnectionInfo ci;
            ci = ConnectionsManager.getConnectionInfoByName( "LIAS Checklists" );        // databaseName           
            qrst = new QueryResultSetTable( ci.getConnection(), "SELECT * FROM checklists_header;" );
        }
        catch( Exception ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        
        setGridViewPanel( qrst );
*/                
        addFileMenuItem( "plugin.checklists.file.import_from_list",     new java.awt.event.ActionListener()
            {
                public void actionPerformed( java.awt.event.ActionEvent evt )
                {
                        importListActionPerformed( evt );
                }
            }
        );
        addFileMenuItem( "plugin.checklists.file.import_xml_checklist",     new java.awt.event.ActionListener()
            {
                public void actionPerformed( java.awt.event.ActionEvent evt )
                {
                        importActionPerformed( evt );
                }
            }
        );
        addFileMenuItem( "plugin.checklists.file.export_xml_checklist",     new java.awt.event.ActionListener()
            {
                public void actionPerformed( java.awt.event.ActionEvent evt )
                {
                        exportActionPerformed( evt );
                }
            }
        );
        addFileMenuItem( "plugin.checklists.file.convert_checklist_to_xml",     new java.awt.event.ActionListener()
            {
                public void actionPerformed( java.awt.event.ActionEvent evt )
                {
                    convertToXmlActionPerformed( evt );
                }
            }
        );
        addFileMenuItem( "plugin.checklists.file.gis_data",     new java.awt.event.ActionListener()
            {
                public void actionPerformed( java.awt.event.ActionEvent evt )
                {
                        gisDataActionPerformed( evt );
                }
            }
        );
        addFileMenuItem( "plugin.checklists.file.gis_cross_data",     new java.awt.event.ActionListener()
            {
                public void actionPerformed( java.awt.event.ActionEvent evt )
                {
                        gisCrossDataActionPerformed( evt );
                }
            }
        );
 
        setMapPanel( new net.metadiversity.diversity.navigator.gui.ChecklistsGisVisualisation( db.connect() ) );
        // jPanelFilter = new ProjectQueryPanel( this ); 
        // jTabbedPane1.addTab( "Filter", jPanelFilter );
        this.pack();
        this.setVisible( true );
    }
    
    //--------------------------------------------------------------------------
    // Menu Actions
    //--------------------------------------------------------------------------
    
    //--------------------------------------------------------------------------
    // Convert orgi. Checklist to XML_Checklist
    //--------------------------------------------------------------------------
    private void convertToXmlActionPerformed (java.awt.event.ActionEvent evt)
    {
        logger.info( "Convert checklist" );
        // Read original Checklist and convert it to XML-Checklist
	javax.swing.JFileChooser chooser = new javax.swing.JFileChooser();
        chooser.setFileFilter( new ChecklistFileFilter() );
	int ret = chooser.showDialog( null, "Convert checklist" );
        if( ret == javax.swing.JFileChooser.APPROVE_OPTION ) 
        {
            String fullpath = chooser.getSelectedFile().getPath();
            String msg = "Convert checklist from file: " + fullpath;
            logger.info( msg );
            DnOptionPane.showMessageDialog( null, msg, "Information", DnOptionPane.INFORMATION_MESSAGE );

            ChecklistFileName importFilename = new ChecklistFileName( fullpath );                

            ImportDataFile idf = new ImportDataFile();

            idf.convertToXmlFile( importFilename );                
        }
        else
        {
            logger.info( "Abort convert checklist" );
        }
        return;
    }
    //--------------------------------------------------------------------------
    // Import Checklist
    //--------------------------------------------------------------------------
    private void importActionPerformed (java.awt.event.ActionEvent evt)
    {
        logger.info( "checklist import" );
        // Read original XML Checklist and insert into database
        javax.swing.JFileChooser chooser = new javax.swing.JFileChooser();
        chooser.setFileFilter( new ChecklistFileFilter() );
	int ret = chooser.showDialog( this, "checklist import" );
       
        if( ret == javax.swing.JFileChooser.APPROVE_OPTION ) 
        {
            String fullpath = chooser.getSelectedFile().getPath();
            String msg = "Import checklist from file: " + fullpath;
            logger.info( msg );
            DnOptionPane.showMessageDialog( null, msg, "Information", DnOptionPane.INFORMATION_MESSAGE );
            StringBuffer importFileName = new StringBuffer();
            importFileName.append( fullpath );
            // read XML-Checklist
            XmlConfigurationImpl xmlData = new XmlConfigurationImpl( importFileName.toString() );
            xmlData.importChecklist( db );
        }    
        else
        {
            logger.info( "Abort import checklist from file" );
        }
	return;
    }
    //--------------------------------------------------------------------------
    // Import Checklists specified in a file list
    //--------------------------------------------------------------------------
    private void importListActionPerformed (java.awt.event.ActionEvent evt)
    {
        logger.info( "Import a list of xml files" );
        // Read original XML Checklist and insert into database
        javax.swing.JFileChooser chooser = new javax.swing.JFileChooser();
	int ret = chooser.showDialog( null, "Import a list of xml files" );
        if( ret == javax.swing.JFileChooser.APPROVE_OPTION ) 
        {
            String fullpath = chooser.getSelectedFile().getPath();
            String msg = "Import a list of xml files: " + fullpath;
            logger.info( msg );
            DnOptionPane.showMessageDialog( null, msg, "Information", DnOptionPane.INFORMATION_MESSAGE );
            String filename = fullpath;
            //---------------
            // read list file
            //---------------                
            java.io.BufferedReader          input     = null;    
            try
            {
                try
                {
                    input = new java.io.BufferedReader( new java.io.InputStreamReader( new java.io.FileInputStream( filename ), "UTF-8" ) );
                }
                catch( java.io.UnsupportedEncodingException ex )
                {
                    DnOptionPane.showMessageDialog( null, ex.toString(), "Error" , DnOptionPane.ERROR_MESSAGE );
                }
            }
            catch( java.io.FileNotFoundException ex )
            {
                msg = "File not found: " + filename + ":\n";
                DnOptionPane.showMessageDialog( null, msg, "Error", DnOptionPane.ERROR_MESSAGE );
            }

            try
            {
                while( input.ready() )
                {
                    String line = input.readLine();
                    if( line.trim().length() == 0 )
                    {
                        continue;
                    }
                    ChecklistFileName importFilename = new ChecklistFileName( line.trim() );

                    logger.info( "\nImport File: " + importFilename.getDefaultFilename() + "\n" );
                    //---------------------
                    // convert to xml file
                    //---------------------

                    ImportDataFile idf = new ImportDataFile();        

                    if( idf.convertToXmlFile( importFilename ) == false )
                    {
                        DnOptionPane.showMessageDialog( null, "There was an error when converting to xml file", "Error", DnOptionPane.ERROR_MESSAGE );
                        continue;
                    }
                    //---------------------
                    // read XML-Checklist
                    //---------------------                
                    XmlConfigurationImpl xmlData = new XmlConfigurationImpl( importFilename.getXmlFilename() );
                    xmlData.importChecklist( db );       
                }    
            }
            catch( Exception ex )
            {
                logger.fatal( "ex: " + ex.getMessage());
                DnOptionPane.showMessageDialog( null, ex.getMessage(), "Error", DnOptionPane.ERROR_MESSAGE );
            }
        }
        else
        {
            logger.info( "Abort import a list of xml files" );
        }
	return;
    }
    //--------------------------------------------------------------------------
    // Export
    //--------------------------------------------------------------------------
    private void exportActionPerformed (java.awt.event.ActionEvent evt)
    {
	// Export Checklist

	//	java.atw.FileDialog fd = new java.atw.FileDialog( null, "Import checklist " );

	logger.info( "Export" );
	javax.swing.JFileChooser chooser = new javax.swing.JFileChooser();
	chooser.showDialog( null, "Export checklist" );

	// Note: source for ExampleFileFilter can be found in FileChooserDemo,
	// under the demo/jfc directory in the Java 2 SDK, Standard Edition.
	/*
	ExampleFileFilter filter = new ExampleFileFilter();
	filter.addExtension("jpg");
	filter.addExtension("gif");
	filter.setDescription("JPG & GIF Images");
	chooser.setFileFilter(filter);
	int returnVal = chooser.showOpenDialog(parent);

	if(returnVal == JFileChooser.APPROVE_OPTION)
	{
	    logger.fatal( "You chose to open this file: " +  chooser.getSelectedFile().getName() );
	}
	*/
	return;
    }
    //--------------------------------------------------------------------------
    // Gis Data
    //--------------------------------------------------------------------------
    private void gisDataActionPerformed( java.awt.event.ActionEvent evt )
    {
	logger.info( "Save Gis Data" );
        // get output filename
        java.io.File file;            
        javax.swing.JFileChooser fc = new javax.swing.JFileChooser();
        fc.setDialogType( javax.swing.JFileChooser.SAVE_DIALOG );
        fc.setDialogTitle( "Grass Gis location list" );
        fc.setFileSelectionMode( javax.swing.JFileChooser.FILES_ONLY );
        int ret = fc.showSaveDialog( this );
        if( ret == javax.swing.JFileChooser.APPROVE_OPTION ) 
        {
            String fullpath = fc.getSelectedFile().getPath();
            logger.info( "Write file: " + fullpath +" ..." );
            StringBuffer data = null; 
            try
            {
                data = db.readGisData();
            }
            catch( java.sql.SQLException ex )
            {
                logger.error( ex.getMessage(), ex.fillInStackTrace() );            
            }

            WriteUnicodeFile wuf = new WriteUnicodeFile( fullpath, data.toString() );
            logger.info( "finish" );
        }				        
	return;
    }
    //--------------------------------------------------------------------------
    // Gis Cross Data
    //--------------------------------------------------------------------------
    private void gisCrossDataActionPerformed( java.awt.event.ActionEvent evt )
    {
	logger.info( "Save Gis Cross Data" );
        // get output filename
        java.io.File file;            
        javax.swing.JFileChooser fc = new javax.swing.JFileChooser();
        fc.setDialogType( javax.swing.JFileChooser.SAVE_DIALOG );
        fc.setDialogTitle( "Grass Gis cross location list" );
        fc.setFileSelectionMode( javax.swing.JFileChooser.FILES_ONLY );
        int ret = fc.showSaveDialog( this );
        if( ret == javax.swing.JFileChooser.APPROVE_OPTION ) 
        {
            String fullpath = fc.getSelectedFile().getPath();
            logger.info( "Write file: " + fullpath +" ..." );
            StringBuffer data = null;
            try
            {
                data = db.readGisCrossData();
            }
            catch( java.sql.SQLException ex )
            {
                logger.error( ex.getMessage(), ex.fillInStackTrace() );            
            }
            WriteUnicodeFile wuf = new WriteUnicodeFile( fullpath, data.toString() );
            logger.info( "finish" );
        }				        
	return;
    }
    
    private void jMenuItemExitActionPerformed( java.awt.event.ActionEvent evt )
    {
	this.setVisible( false );
    }
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt)
    {
        System.exit (0);
    }
    
    
}
