/*
 * DetailTableModel.java
 *
 * Created on 22. Mai 2003, 12:50
 */

package net.metadiversity.diversity.navigator.table;

import javax.swing.table.*;
//import javax.swing.table.TableCellRenderer;
// import javax.swing.DefaultCellEditor;

import org.apache.log4j.Logger;
/**
 *
 * @author  didi
 */
public class DetailsTableModel extends AbstractTableModel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3689353230035400504L;

    static Logger logger = Logger.getLogger( DetailsTableModel.class.getName() );
    
    String [] colNames =
    {
        "Name", "Type", "Not Null", "Default"
    };
    
    Class[] colTypes = new Class []
    {
        java.lang.String.class, 
        java.lang.String.class, 
        java.lang.Boolean.class, 
        java.lang.String.class
    };
    
    boolean[] colCanEdit = new boolean []
    {
        false, false, false, false
    };

    TableTableModel resultModel; 

    public DetailsTableModel( TableTableModel resultModel )
    {
         if( logger.isDebugEnabled() ) logger.debug( "DetailsTableModel()" );
        this.resultModel = resultModel;
    }
    
    public int getColumnCount()
    {
        return 4;
    }
    
    public int getRowCount()    
    {
        return resultModel.getTablesDetailsCount();
    }
    
    public Object getValueAt( int row, int col )    
    {
        return  resultModel.getTableColumnDetails( row, col ); 
    }
    
    public Class getColumnClass(int columnIndex)
    {
        return colTypes[ columnIndex ];
    }

    public boolean isCellEditable( int rowIndex, int columnIndex )
    {
        return colCanEdit[ columnIndex ];
    }
    
    public String getColumnName( int i )
    {
        return colNames[ i ];
    }        
}
