package net.metadiversity.diversity.navikey.bo;
/*
 * DeltaInterface defines the methods needed to interact and work with our
 * delta data model
 * by defining through an interface, different implementations of the Delta
 * logic can be made, through a direct connection or intermediary like
 * a client-server interaction
 *
 * @author Michael Bartley
 * @author Dieter Neubacher
 */
import java.util.Vector;

public interface DeltaInterface
{
    //the intelligence flag indicates whether or not shrinking lists occur
    public Vector getItemCharacterList(Vector basicStates, boolean intelligent, boolean depentencies );//, boolean intelligence); //vector of BasicItemCharacters returned
    public Vector getStateList(Vector basicStates, Object characterId, boolean intelligent );//, boolean intelligence); //vector of BasicStates returned
    public Vector getItemList(Vector basicStates); //vector of BasicItems returned
    public BasicItemCharacter getBasicItemCharacter(Object itemCharacterId);
    public Item getItem(Object itemId); //for use in generating description list
    public String getItemTitle(Object itemId);
    public Vector getItemDescription(Object itemId);
    public Vector getItemResources(Object itemId);
}
