package net.metadiversity.diversity.navikey.bo;

import net.metadiversity.diversity.navikey.ui.NaviKey;

import java.util.Vector;

/**
 * @author Michael Bartley
 * @author Noel Cross
 */

public class TextAttribute extends Attribute
{
    private TextState ts;
    private String comment;
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public TextAttribute()
    {
        super();
        ts = new TextState();
        comment = "";
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setTextState(TextState ts)
    {
        this.ts = ts;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setComment(String comment)
    {
        this.comment = comment;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public TextState getTextState()
    {
        return ts;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public String getComment()
    {
        return comment;
    }    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void addCommentedState(State s, String str)
    {
        ts = (TextState)s;
        comment = str;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public Vector getCommentedStates()
    {
        Vector v = new Vector();
        CommentedState cs = new CommentedState(ts, comment);
        v.addElement(cs);
        return v;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public boolean sameAs( NaviKey navikey, Attribute a)
    {
        boolean same = false;
        try
        {
            TextState ts = this.getTextState();
            String value = ts.getValue();
            
            TextAttribute ta2 = (TextAttribute)a;
            TextState ts2 = ta2.getTextState();
            
            if(value.equals(ts2.getValue()))
            {
                same = true;
            }
        }catch (Exception e)
        {
            System.err.println(e);
        }
        return same;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public Vector getStates()
    {
        Vector v = new Vector();
        v.addElement(ts);
        return v;
    }    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public boolean containsState(State st)
    {
        Vector v = getStates();
        for( int i = 0; i < v.size(); i++ )
        {
            State st2 = (State)v.elementAt(i);
            if( st == st2 )
            {
                return true;
            }
        }
        return false;
    }    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void print()
    {
        System.out.println(toString());
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public String toString()
    {
        StringBuffer sb = new StringBuffer();
        sb.append("ItemCharacter: " + ic.getId() + ". " + ic.getFeature());
        if(comment != null)
        {
            sb.append(comment);
        }
        if(ts != null)
        {
            sb.append(ts.toString());
        }
        if(comment != null)
        {
            sb.append(comment);
        }
        return new String(sb);
    }
}
